"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var Component_1 = require("./Component");
var parseTemplate_1 = require("./parseTemplate");
var env = require("./env");
function instantiateComponentFromTemplate(template, properties, compiler, injector) {
    if (properties === void 0) { properties = {}; }
    // Parse the Angular template before compiling it in a module. It throws if the template is invalid.
    parseTemplate_1.parseTemplate(template);
    var types = env.inferComponentsFromTemplate(template);
    var SharedModule = require('@radzen/angular/dist/shared').SharedModule;
    var imports = types.map(function (type) {
        var exports = require("@radzen/angular/dist/" + env.file(type));
        var componentModule = exports[env.componentType(type) + "Module"];
        if (!componentModule) {
            console.log(name);
        }
        return componentModule;
    });
    var DynamicComponent = /** @class */ (function () {
        function DynamicComponent() {
            Object.assign(this, properties);
        }
        DynamicComponent = __decorate([
            core_1.Component({
                template: template
            }),
            __metadata("design:paramtypes", [])
        ], DynamicComponent);
        return DynamicComponent;
    }());
    var DynamicModule = /** @class */ (function () {
        function DynamicModule() {
        }
        DynamicModule = __decorate([
            core_1.NgModule({
                imports: [common_1.CommonModule, SharedModule].concat(imports),
                schemas: [core_1.NO_ERRORS_SCHEMA],
                entryComponents: [DynamicComponent],
                declarations: [DynamicComponent]
            })
        ], DynamicModule);
        return DynamicModule;
    }());
    var moduleFactory = compiler.compileModuleSync(DynamicModule);
    var moduleRef = moduleFactory.create(injector);
    var componentFactory = moduleRef.componentFactoryResolver.resolveComponentFactory(DynamicComponent);
    return componentFactory.create(injector, null, null, moduleRef);
}
function renderComponent(properties) {
    return env.renderComponent(Component_1.parseComponent(properties));
}
var AppComponent = /** @class */ (function () {
    function AppComponent(ngZone, compiler, appRef) {
        this.ngZone = ngZone;
        this.compiler = compiler;
        this.appRef = appRef;
    }
    AppComponent.prototype.loadComponent = function (properties, data, injector) {
        //console.time(`renderComponent ${properties.name}`);
        var template = renderComponent(properties);
        //console.timeEnd(`renderComponent ${properties.name}`);
        //console.time(`instantiateComponentFromTemplate ${properties.name}`);
        var componentRef = instantiateComponentFromTemplate(template, Object.assign({}, properties, data, {
            components: [properties]
        }), this.compiler, injector);
        //console.timeEnd(`instantiateComponentFromTemplate ${properties.name}`);
        this.containerRef.insert(componentRef.hostView);
        //console.time(`run ${properties.name}`);
        this.ngZone.run(function () {
            componentRef.changeDetectorRef.detectChanges();
        });
        //console.timeEnd(`run ${properties.name}`);
        return componentRef;
    };
    __decorate([
        core_1.ViewChild('container', { read: core_1.ViewContainerRef }),
        __metadata("design:type", core_1.ViewContainerRef)
    ], AppComponent.prototype, "containerRef", void 0);
    AppComponent = __decorate([
        core_1.Component({
            selector: 'radzen-app',
            template: '<div #container></div>'
        }),
        __metadata("design:paramtypes", [core_1.NgZone,
            core_1.Compiler,
            core_1.ApplicationRef])
    ], AppComponent);
    return AppComponent;
}());
exports.AppComponent = AppComponent;
//# sourceMappingURL=AppComponent.js.map