"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var child_process = require("child_process");
var fs_1 = require("./fs");
function buildCultures(_a) {
    var localization = _a.localization, directory = _a.directory, onStart = _a.onStart;
    return new Promise(function (resolve, reject) {
        var options = [
            require.resolve('@angular/cli/bin/ng'),
            'xi18n',
            '--progress',
            'false',
            '--output-path',
            "" + path_1.join(directory, 'client', 'src', 'i18n'),
            '--i18n-locale',
            "" + localization.defaultCulture.value
        ];
        var child = child_process.spawn(process.execPath, options, {
            cwd: path_1.join(directory, 'client'),
            env: Object.assign({ ELECTRON_RUN_AS_NODE: 1 }, process.env)
        });
        onStart(child);
        child.on('exit', function (code) {
            if (code > 0) {
                console.log('ng-cli:', "Build failed");
                reject();
            }
            else {
                resolve();
            }
        });
        child.on('error', function (error) {
            console.log('ng-cli:', error.toString());
            reject();
        });
        console.log('radzen: Building Angular application cultures ...');
        child.stdout.on('data', function (data) {
            console.log('ng-cli:', data.toString());
        });
        child.stderr.on('data', function (data) {
            console.log('ng-cli:', data.toString());
        });
    });
}
function buildCulturesXLF(_a) {
    var localization = _a.localization, directory = _a.directory, onStart = _a.onStart;
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_b) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    var child = child_process.spawn(process.execPath, [require.resolve('@angular/cli/bin/ng'), 'run', 'client:xliffmerge'], {
                        cwd: path_1.join(directory, 'client'),
                        env: Object.assign({ ELECTRON_RUN_AS_NODE: 1 }, process.env)
                    });
                    onStart(child);
                    child.on('exit', function (code) {
                        if (code > 0) {
                            console.log('xliffmerge:', "Failed");
                            reject();
                        }
                        else {
                            resolve();
                        }
                    });
                    child.on('error', function (error) {
                        console.log('xliffmerge:', error.toString());
                        reject();
                    });
                    console.log('radzen: Building Angular application cultures translations ...');
                    child.stdout.on('data', function (data) {
                        console.log('xliffmerge:', data.toString());
                    });
                    child.stderr.on('data', function (data) {
                        console.log('xliffmerge:', data.toString());
                    });
                })];
        });
    });
}
function linkNodeModules(options) {
    return removeLink(options.directory).then(function () {
        return fs_1.symlink(options.modules, path_1.join(options.directory, 'client', 'node_modules'), 'junction').then(function () {
            // console.log('symlink created');
        }, function (err) {
            if (err.code == 'EEXIST') {
                // console.log('symlink exists');
            }
            else {
                // console.error('symlink creating failed', err);
                throw err;
            }
        });
    });
}
exports.linkNodeModules = linkNodeModules;
function removeLink(path) {
    var dir = path_1.join(path, 'client', 'node_modules');
    return fs_1.lstat(dir).then(function (stats) {
        if (stats.isSymbolicLink()) {
            return fs_1.unlink(dir).then(function () { }, function (err) {
                if (err.code != 'ENOENT') {
                    throw err;
                }
            });
        }
    }, function (err) {
        if (err.code != 'ENOENT') {
            throw err;
        }
    });
}
function cultureArguments(culture, application) {
    var options = [];
    if (culture) {
        options.push("--aot");
        options.push("--i18n-file", "src/i18n/messages." + culture.value + ".xlf");
        options.push("--i18n-locale", "" + culture.value);
        options.push("--i18n-format", "xlf");
        if (!application) {
            options.push("--output-path", "dist/" + culture.value);
        }
    }
    return options;
}
function serveArguments(application) {
    var options = [
        require.resolve('@angular/cli/bin/ng'),
        'serve',
        '--host',
        '0.0.0.0',
        '--port',
        "" + application.port
    ];
    if (application.https) {
        options.push('--ssl', 'true');
        options.push('--ssl-key', 'ssl/server.key');
        options.push('--ssl-cert', 'ssl/server.crt');
    }
    if (application.localization) {
        options.push('--configuration', application.localization.defaultCulture.value);
    }
    return options;
}
function buildArguments(baseHref, culture) {
    var options = [
        '--max_old_space_size=8192',
        require.resolve('@angular/cli/bin/ng'),
        'build',
        '--prod',
        '--preserve-symlinks',
        'true'
    ];
    options.push.apply(options, cultureArguments(culture));
    if (baseHref && !baseHref.endsWith('/')) {
        baseHref += '/';
    }
    return baseHref ? options.concat(['--base-href', baseHref]) : options;
}
function executeBuild(_a, commandArguments, batch) {
    var application = _a.application, directory = _a.directory, onStart = _a.onStart, onExit = _a.onExit, onSuccess = _a.onSuccess;
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_b) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    var start = Date.now();
                    var child = child_process.spawn(process.execPath, commandArguments, {
                        cwd: path_1.join(directory, 'client'),
                        env: Object.assign({ ELECTRON_RUN_AS_NODE: 1 }, process.env)
                    });
                    onStart(child);
                    child.on('error', function (error) {
                        console.log('ng-cli:', error.toString());
                        removeLink(directory);
                        reject();
                    });
                    child.on('exit', function (code) {
                        if (!batch) {
                            removeLink(directory);
                        }
                        if (code > 0) {
                            console.log('ng-cli:', "Build failed");
                            reject();
                        }
                        else {
                            if (!application) {
                                console.log('radzen:', "Angular application production build done in " + (Date.now() -
                                    start) + "ms.");
                            }
                            if (!batch) {
                                onExit();
                            }
                            resolve();
                        }
                    });
                    if (!application && !batch) {
                        console.log('radzen: Building Angular application in production ...');
                    }
                    child.stdout.on('data', function (data) {
                        var message = data.toString();
                        console.log('ng-cli:', message);
                        if (onSuccess &&
                            /(Compiled with warnings|Compiled successfully)/.test(message)) {
                            onSuccess();
                        }
                    });
                    child.stderr.on('data', function (data) {
                        console.log('ng-cli:', data.toString());
                    });
                })];
        });
    });
}
function build(options) {
    return __awaiter(this, void 0, void 0, function () {
        var localization, application, baseHref, onExit, onError, cultures, i, culture, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    localization = options.localization, application = options.application, baseHref = options.baseHref, onExit = options.onExit, onError = options.onError;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 14, , 15]);
                    if (!localization) return [3 /*break*/, 11];
                    cultures = localization.cultures;
                    return [4 /*yield*/, buildCultures(options)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, buildCulturesXLF(options)];
                case 3:
                    _a.sent();
                    if (!application) return [3 /*break*/, 5];
                    return [4 /*yield*/, executeBuild(options, serveArguments(application))];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 10];
                case 5:
                    i = 0;
                    _a.label = 6;
                case 6:
                    if (!(i < cultures.length)) return [3 /*break*/, 9];
                    culture = cultures[i];
                    console.log("radzen: Building Angular application in production for " + culture.text + " culture...");
                    return [4 /*yield*/, executeBuild(options, buildArguments((baseHref == '/' || !baseHref ? '' : baseHref) + "/" + culture.value, culture), true)];
                case 7:
                    _a.sent();
                    _a.label = 8;
                case 8:
                    i++;
                    return [3 /*break*/, 6];
                case 9:
                    onExit();
                    _a.label = 10;
                case 10: return [3 /*break*/, 13];
                case 11: return [4 /*yield*/, executeBuild(options, application ? serveArguments(application) : buildArguments(baseHref))];
                case 12:
                    _a.sent();
                    _a.label = 13;
                case 13: return [3 /*break*/, 15];
                case 14:
                    e_1 = _a.sent();
                    if (e_1) {
                        console.log("radzen: " + e_1);
                    }
                    onError();
                    return [3 /*break*/, 15];
                case 15: return [2 /*return*/];
            }
        });
    });
}
exports.build = build;
//# sourceMappingURL=build.js.map