"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var rimraf = require("rimraf");
var path_1 = require("path");
var Ignore = require('ignore');
var child_process = require("child_process");
var lodash_1 = require("lodash");
var dotenv = require("dotenv");
var _a = require('semver'), lt = _a.lt, gt = _a.gt;
var merge_project_1 = require("./merge-project");
var merge_package_1 = require("./merge-package");
var Component_1 = require("./Component");
var Event_1 = require("./Event");
var Application_1 = require("./Application");
var DataSource_1 = require("./DataSource");
var env = require("./env");
var renderTemplate_1 = require("./renderTemplate");
var fs_1 = require("./fs");
var securityDataSource_1 = require("./securityDataSource");
var fs_2 = require("fs");
__export(require("./toolbox"));
__export(require("./bootstrap"));
__export(require("./build"));
__export(require("./deploy"));
__export(require("./securityDataSource"));
function updateFile(path, content, mergeContent) {
    return fs_1.fileExists(path)
        .then(function (exists) {
        return exists ? fs_1.readFile(path) : null;
    })
        .then(function (original) {
        if (original != content) {
            if (original && mergeContent && path.endsWith('.json')) {
                var originalContentAsJSON = void 0;
                try {
                    originalContentAsJSON = JSON.parse(original);
                }
                catch (err) {
                    throw new Error(path + " is not a valid JSON file - \"" + err.message + "\".\n\n" + original);
                }
                var targetContentAsJSON = void 0;
                try {
                    targetContentAsJSON = JSON.parse(content);
                }
                catch (err) {
                    throw new Error("$Not a valid JSON string - \"" + err.message + "\".\n\n" + content);
                }
                lodash_1.merge(originalContentAsJSON, targetContentAsJSON);
                return fs_1.writeFile(path, JSON.stringify(originalContentAsJSON, null, 2));
            }
            return fs_1.writeFile(path, content);
        }
    });
}
function styles(application) {
    var theme = application.theme;
    var ultima = theme.startsWith('ultima');
    var name = theme.replace('ultima/', '');
    var styles = [
    //join(path, 'client', 'src', 'assets', 'css', `${name}.css`)
    ];
    if (ultima) {
        styles.unshift(require.resolve('primeng/resources/primeng.min.css'));
        styles.unshift(require.resolve('@fullcalendar/core/main.css'));
        styles.unshift(require.resolve('@fullcalendar/daygrid/main.css'));
        styles.unshift(require.resolve('@fullcalendar/timegrid/main.css'));
    }
    return styles;
}
exports.styles = styles;
function copyThemeDir(path, source, name, application) {
    return fs_1.cp(source, path_1.join(path, 'client', 'src', 'assets', name), createIgnore(path, application));
}
exports.copyThemeDir = copyThemeDir;
function customThemePath() {
    return path_1.join('client', 'src', 'assets', 'css');
}
exports.customThemePath = customThemePath;
function copyAssets(path, source, application) {
    return fs_1.cp(source, path_1.join(path, 'client', 'src', 'assets'), createIgnore(path, application));
}
exports.copyAssets = copyAssets;
function setConfigValue(path, key, value) {
    if (!fs.existsSync(path)) {
        fs.mkdirSync(path);
    }
    var file = path_1.join(path, '.env');
    if (!fs.existsSync(file)) {
        fs.writeFileSync(file, '');
    }
    return fs_1.readFile(file)
        .then(function (data) {
        return dotenv.parse(data);
    }, function () { return ({}); })
        .then(function (config) {
        config[key] = value;
        var lines = Object.keys(config).map(function (key) {
            return key + "=\"" + config[key] + "\"";
        });
        return fs_1.writeFile(file, lines.join('\n'));
    });
}
exports.setConfigValue = setConfigValue;
function getConfigValue(path, key, sync) {
    if (sync === void 0) { sync = false; }
    var file = path_1.join(path, '.env');
    if (sync) {
        if (fs.existsSync(file)) {
            var data = fs_2.readFileSync(file, 'utf8');
            var config = dotenv.parse(data);
            return config[key];
        }
        else {
            return null;
        }
    }
    else {
        return fs_1.readFile(file).then(function (data) {
            var config = dotenv.parse(data);
            return config[key];
        }, function () { return null; });
    }
}
exports.getConfigValue = getConfigValue;
function getConnectionString(path, key, sync) {
    if (sync === void 0) { sync = false; }
    return getConfigValue(path, "ConnectionStrings__" + key, sync);
}
exports.getConnectionString = getConnectionString;
function setConnectionString(path, key, value) {
    return setConfigValue(path, "ConnectionStrings__" + key, value);
}
exports.setConnectionString = setConnectionString;
function getDeployData(path, dataFile) {
    var file = dataFile || path_1.join(path, '.settings');
    return fs_1.fileExists(file).then(function (exists) {
        return exists
            ? fs_1.readFile(file).then(function (data) { return JSON.parse(data)['deploy']; })
            : null;
    });
}
exports.getDeployData = getDeployData;
function setDeployData(path, value, dataFile) {
    var file = dataFile || path_1.join(path, '.settings');
    return updateFile(file, JSON.stringify({ deploy: value }));
}
exports.setDeployData = setDeployData;
function saveSSL(path, key, cert, pfx, application) {
    var client = fs_1.ensure(path, 'client');
    var server = fs_1.ensure(path, 'server');
    var ssl = fs_1.ensure(client, 'ssl');
    var ignore = createIgnore(path, application);
    return Promise.all([
        writeFileOnce(path_1.join(ssl, 'server.key'), key, ignore),
        writeFileOnce(path_1.join(ssl, 'server.crt'), cert, ignore),
        writeFileOnce(path_1.join(server, 'server.pfx'), pfx, ignore, { encoding: 'binary' })
    ]);
}
exports.saveSSL = saveSSL;
function createIgnore(appPath, application) {
    var ignore = function (path) { return false; };
    if (Array.isArray(application.ignore)) {
        var matcher_1 = Ignore();
        matcher_1.add(application.ignore.map(function (pattern) {
            return pattern
                .split('\\')
                .join('/')
                .replace('.vb', '.cs');
        }));
        ignore = function (path) {
            return matcher_1.ignores(path_1.relative(appPath, path));
            /*
            const result = matcher.ignores(relative(appPath, path));
      
            if (result) {
              console.log('Ignored: ', relative(appPath, path));
            }
      
            return result;
            */
        };
    }
    return ignore;
}
function ensureSecurityConfiguration(application) {
    if (application.security) {
        if (!application.security.loginPage) {
            throw new Error('Radzen: Security is enabled but no login page is specified.');
        }
        var loginPage = application.pages.find(function (page) { return page.name == application.security.loginPage; });
        if (!loginPage) {
            throw new Error("Radzen: Cannot find " + application.security.loginPage + " which is specified as the login page.");
        }
        var _a = loginPage.access, access = _a === void 0 ? [] : _a;
        if (!Array.isArray(access)) {
            access = [access];
        }
        if (access.indexOf('Everybody') < 0) {
            throw new Error("Radzen: The application login page (\"" + loginPage.name + "\") does not allow access to anonymous users. Open the \"" + loginPage.name + "\" properties and add \"Everybody\" to the access list.");
        }
    }
}
function generate(path, application, isRunning, mode, options) {
    if (isRunning === void 0) { isRunning = false; }
    ensureSecurityConfiguration(application);
    var dataSources = application.dataSources.map(function (d) {
        var runtimePath = null;
        var endPoint = null;
        if (mode == 'deploy') {
            if (d.info['x-connector']) {
                runtimePath = "" + (options.baseHref == '/' || !options.baseHref ? '' : options.baseHref) + d.basePath;
            }
            else {
                var value = options.endPoints[d.info.title].value;
                endPoint = value;
            }
        }
        return DataSource_1.swaggerToDataSource(d, application.https, runtimePath, endPoint);
    });
    var serverDataSourceNames = dataSources
        .filter(function (dataSource) {
        return dataSource.connector == 'mssql' ||
            dataSource.connector == 'mysql' ||
            dataSource.connector == 'postgresql' ||
            dataSource.connector == 'oracle';
    })
        .map(function (dataSource) { return dataSource.name; });
    if (application.security) {
        serverDataSourceNames.push('securityUrl');
    }
    if (env.isDotNet2(application)) {
        serverDataSourceNames.push('serverMethodsUrl');
    }
    var pages = application.pages, _a = application.layouts, layouts = _a === void 0 ? [] : _a;
    var client = fs_1.ensure(path, 'client');
    try {
        var stat = fs.lstatSync(path_1.join(client, 'node_modules'));
        if (stat.isDirectory()) {
            var angular = JSON.parse(fs_2.readFileSync(path_1.join(client, 'node_modules', '@angular', 'core', 'package.json'), 'utf8'));
            if (lt(angular.version, '7.2.0')) {
                throw new Error("Radzen: Angular Version Mismatch " + angular.version);
            }
            var packageJSON = JSON.parse(fs_2.readFileSync(path_1.join(client, 'node_modules', '@radzen', 'angular', 'package.json'), 'utf8'));
            var srcPackageJSON = JSON.parse(fs.readFileSync(path_1.join(__dirname, '..', '..', 'angular', 'package.json'), 'utf8'));
            if (gt(srcPackageJSON.version, packageJSON.version)) {
                throw new Error("Radzen: Version Mismatch " + srcPackageJSON.version + " " + packageJSON.version);
            }
        }
    }
    catch (err) {
        if (/^Radzen:/.test(err.message)) {
            throw err;
        }
    }
    var server = fs_1.ensure(path, 'server');
    var src = fs_1.ensure(client, 'src');
    var assets = fs_1.ensure(src, 'assets');
    var app = fs_1.ensure(src, 'app');
    var environments = fs_1.ensure(src, 'environments');
    var ignore = createIgnore(path, application);
    var baseHref = options && options.baseHref ? options.baseHref.replace(/\/$/, '') : '';
    return Promise.all([
        copyFileOnce(path, 'gitignore', '.gitignore', ignore),
        fs_1.rm(path_1.join(app, 'plus-query-encoder.ts')),
        fs_1.rm(path_1.join(app, 'legacy-odata-query.ts')),
        fs_1.rm(path_1.join(client, '.angular-cli.json')),
        writeTemplate(path_1.join(client, 'angular.json'), 'angular.json.ejs', { application: application }, ignore),
        outputPackageJSON(client, application, dataSources, ignore),
        copy(src, 'tsconfig.json', ignore, isRunning),
        copy(src, 'polyfills.ts', ignore, isRunning),
        copy(src, 'main.ts', ignore, isRunning),
        copyFileOnce(src, 'favicon.ico', 'favicon.ico', ignore),
        copy(assets, 'icon-128x128.png', ignore, isRunning),
        copy(assets, 'icon-152x152.png', ignore, isRunning),
        copy(assets, 'icon-256x256.png', ignore, isRunning),
        copy(assets, 'icon-512x512.png', ignore, isRunning),
        writeTemplateOnce(path_1.join(src, 'ngsw-config.json'), 'ngsw-config.json.ejs', isRunning, ignore),
        writeTemplate(path_1.join(src, 'manifest.json'), 'manifest.json.ejs', application, ignore),
        writeTemplate(path_1.join(src, 'styles-generated.css'), 'styles-generated.css.ejs', application, ignore),
        writeTemplateOnce(path_1.join(src, 'styles.css'), 'styles.css.ejs', application, ignore),
        writeTemplate(path_1.join(environments, 'environment.ts'), 'environment.ts.ejs', {
            application: application,
            dataSources: dataSources,
            options: options,
            baseHref: baseHref,
            mode: mode,
            dataSourceName: dataSourceName
        }, ignore),
        writeTemplate(path_1.join(environments, 'environment.prod.ts'), 'environment.prod.ts.ejs', { application: application, dataSources: dataSources, baseHref: baseHref, options: options, mode: mode, dataSourceName: dataSourceName }, ignore),
        outputODataServices(path, server, application, dataSources, isRunning, mode, options, ignore),
        application.security
            ? outputClientSecurity(app, application, pages, dataSources, ignore)
            : removeSecurity(app),
        outputDataSources(app, application, dataSources, ignore),
        outputPages(app, application, pages, dataSources, mode == 'deploy' ? options : null, ignore),
        fs_1.fileExists(path_1.join(assets, 'config.json')).then(function (config) {
            return writeTemplate(path_1.join(app, 'config.service.ts'), 'config.service.ts.ejs', {
                config: config
            }, ignore);
        }),
        outputLayouts(app, application, layouts, dataSources, mode == 'deploy' ? options : null, ignore),
        writeAppModule(app, application, dataSources, serverDataSourceNames, pages, layouts, ignore),
        writeTemplate(path_1.join(src, 'index.html'), 'index.html.ejs', application, ignore),
        writeTemplate(path_1.join(app, 'app.routes.ts'), 'app.routes.ts.ejs', Object.assign({ security: null }, application, {
            pages: pages,
            pagesByLayout: lodash_1.groupBy(pages, 'layout'),
            layouts: layouts,
            parameters: pageParameters(pages)
        }), ignore),
        serverDataSourceNames.length > 0
            ? writeTemplate(path_1.join(app, 'cache.interceptor.ts'), 'cache.interceptor.ts.ejs', {
                serverDataSourceNames: serverDataSourceNames
            }, ignore)
            : fs_1.rm(path_1.join(app, 'cache.interceptor.ts')),
        writeTemplate(path_1.join(app, 'app.component.ts'), 'app.component.ts.ejs', Object.assign({ security: null, mode: mode, localization: null }, application, {
            pages: pages,
            dataSources: dataSources
        }), ignore),
        writeTemplate(path_1.join(app, 'app.component.html'), 'app.component.html.ejs', Object.assign({ logo: null, security: null, mode: mode, localization: null, env: env }, application, {
            pages: pages
        }), ignore)
    ]);
}
exports.generate = generate;
function restorePackages(cwd, env, onStart) {
    console.log('dotnet: ', 'Restoring packages ...');
    return new Promise(function (resolve, reject) {
        var child = child_process.spawn('dotnet', ['restore'], { cwd: cwd, env: env });
        onStart(child);
        child.on('error', reject);
        child.on('exit', function (code) {
            if (typeof code != 'number') {
                // stopped by user
                resolve(false);
            }
            else if (code > 0) {
                // exit with error
                reject();
            }
            else {
                // exit successfully
                resolve(true);
            }
        });
        child.stderr.on('data', function (data) {
            console.log('dotnet:', data.toString());
        });
        child.stdout.on('data', function (data) {
            console.log('dotnet:', data.toString());
        });
    });
}
function startServer(_a) {
    var command = _a.command, serverVersion = _a.serverVersion, options = _a.options, successMessage = _a.successMessage, directory = _a.directory, onStart = _a.onStart, onError = _a.onError, onExit = _a.onExit, onSuccess = _a.onSuccess;
    var cwd = path_1.join(directory, 'server');
    var success = false;
    var env = Object.assign({
        ASPNETCORE_ENVIRONMENT: 'Development',
        RADZEN: true,
        UseRazorBuildServer: false,
        UseSharedCompilation: false
    }, process.env);
    if (env.hasOwnProperty('Path') && env.hasOwnProperty('PATH')) {
        delete env.Path;
    }
    var dotnetRun = function () {
        var child = child_process.spawn('dotnet', [command, options], { cwd: cwd, env: env });
        onStart(child);
        child.on('error', onError);
        child.on('exit', function (code) {
            if (code > 0) {
                onError();
            }
            else {
                onExit();
            }
        });
        child.stderr.on('data', function (data) {
            console.log('dotnet:', data.toString());
        });
        child.stdout.on('data', function (data) {
            var message = data.toString();
            console.log('dotnet:', message);
            if (message.includes(successMessage) && !success) {
                success = true;
                onSuccess();
            }
        });
    };
    if (serverVersion == '1') {
        restorePackages(cwd, env, onStart).then(function (completed) {
            if (!completed) {
                return;
            }
            dotnetRun();
        }, onError);
    }
    else {
        dotnetRun();
    }
}
exports.startServer = startServer;
function supportsServer() {
    var _this = this;
    return new Promise(function (resolve, reject) {
        if (process.platform == 'win32') {
            child_process.exec('dotnet --version', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                var sdks;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (err) {
                                console.error(err);
                                return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                            }
                            return [4 /*yield*/, installedDotNetCoreSDKs()];
                        case 1:
                            sdks = _a.sent();
                            resolve(sdks);
                            return [2 /*return*/];
                    }
                });
            }); });
        }
        else if (process.platform == 'darwin') {
            child_process.exec('ls /usr/local/share/dotnet/shared/Microsoft.NETCore.App/', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (err) {
                        console.error(err);
                        return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                    }
                    resolve(stdout.split('\n'));
                    return [2 /*return*/];
                });
            }); });
        }
        else {
            child_process.exec('dotnet --version', function (err, stdout, stderr) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (err) {
                        console.error(err);
                        return [2 /*return*/, reject('Microsoft .NET Core not installed.')];
                    }
                    resolve([stdout.trim()]);
                    return [2 /*return*/];
                });
            }); });
        }
    });
}
exports.supportsServer = supportsServer;
function installedDotNetCoreSDKs() {
    return __awaiter(this, void 0, void 0, function () {
        var relativePath, dotnet64Path, path32, dotnet32Path, dotnetPath, _a, sdks;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    relativePath = 'dotnet/sdk';
                    dotnet64Path = path_1.resolve(path_1.join(process.env.ProgramFiles, relativePath));
                    path32 = process.env['ProgramFiles(x86)'];
                    dotnet32Path = path32 ? path_1.resolve(path_1.join(path32, relativePath)) : null;
                    if (fs.existsSync(dotnet64Path)) {
                        dotnetPath = dotnet64Path;
                    }
                    else if (dotnet32Path && fs.existsSync(dotnet32Path)) {
                        dotnetPath = dotnet32Path;
                    }
                    _a = dotnetPath;
                    if (!_a) return [3 /*break*/, 2];
                    return [4 /*yield*/, fs_1.dirExists(dotnetPath)];
                case 1:
                    _a = (_b.sent());
                    _b.label = 2;
                case 2:
                    if (!_a) return [3 /*break*/, 4];
                    return [4 /*yield*/, fs_1.readdir(dotnetPath)];
                case 3:
                    sdks = _b.sent();
                    return [2 /*return*/, sdks.filter(function (i) { return i != 'NuGetFallbackFolder'; })];
                case 4: return [2 /*return*/, []];
            }
        });
    });
}
function getPathByLanguage(application, path) {
    return env.isDotNet2(application) && application.serverLang == 'vb'
        ? path.replace('.cs', '.vb')
        : path;
}
function getServerTemplate(application, path) {
    return env.isDotNet2(application)
        ? path_1.join('core2', getPathByLanguage(application, path))
        : path;
}
function writeServerTemplateOnce(application, path, template, data, ignore) {
    var filePath = getPathByLanguage(application, path);
    return fs_1.fileExists(filePath).then(function (exists) {
        if (!exists) {
            return writeServerTemplate(application, path, template, data, ignore);
        }
    });
}
function writeServerTemplate(application, path, template, data, ignore, merge) {
    if (ignore(path)) {
        return;
    }
    if (env.isDotNet2(application) &&
        application.serverLang == 'vb' &&
        path.indexOf('.cshtml') != -1) {
        return Promise.resolve();
    }
    if (!env.isDotNet2(application) && path.indexOf('OutputFormatter.cs') != -1) {
        return Promise.resolve();
    }
    path = getPathByLanguage(application, path);
    return renderTemplate_1.renderTemplate(getServerTemplate(application, template), data).then(function (output) { return updateFile(path, output, merge); });
}
function dataSourceName(name) {
    return name.indexOf(' ') != -1 ||
        name.indexOf('_') != -1 ||
        name.indexOf('-') != -1
        ? lodash_1.upperFirst(lodash_1.camelCase(name))
        : name;
}
function outputODataServices(appPath, path, application, dataSources, isRunning, mode, options, ignore) {
    var odataDataSources = dataSources.filter(function (dataSource) {
        return dataSource.connector == 'mssql' ||
            dataSource.connector == 'mysql' ||
            dataSource.connector == 'postgresql' ||
            dataSource.connector == 'oracle';
    });
    odataDataSources.forEach(function (dataSource) {
        var connectionString = getConnectionString(appPath, dataSourceName(dataSource.name) + "Connection", true);
        if (!connectionString) {
            throw new Error("Radzen: Connection settings of the \"" + dataSource.name + "\" data source are missing. Go to the \"data\" screen and enter database connection details.");
        }
    });
    if (application.serverProject) {
        fs_1.ensure(path);
        fs_1.ensure(path_1.join(path, 'Models'));
        fs_1.ensure(path_1.join(path, 'Controllers'));
        fs_1.ensure(path_1.join(path, 'Views'));
        fs_1.ensure(path_1.join(path, 'Views', 'Home'));
        fs_1.ensure(path_1.join(path, 'Data'));
        if (env.isDotNet2(application) && mode != 'deploy') {
            fs_1.ensure(path_1.join(path, 'Properties'));
        }
        var models = odataDataSources.map(function (dataSource) {
            return outputODataModels(path, application, dataSource, ignore);
        });
        var controllers = odataDataSources.map(function (dataSource) {
            return outputODataControllers(path, application, dataSource, ignore);
        });
        var contexts = odataDataSources.map(function (dataSource) {
            return outputODataContext(path, application, dataSource, ignore);
        });
        return Promise.all([
            !application.security &&
                fs.existsSync(path_1.join(path, 'Authentication')) &&
                rimraf.sync(path_1.join(path, 'Authentication')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Data', 'Migrations')) &&
                rimraf.sync(path_1.join(path, 'Data', 'Migrations')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Data', 'ApplicationIdentityDbContext.cs')) &&
                fs.unlinkSync(path_1.join(path, 'Data', 'ApplicationIdentityDbContext.cs')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Models', 'ApplicationUser.cs')) &&
                fs.unlinkSync(path_1.join(path, 'Models', 'ApplicationUser.cs')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Controllers', 'AuthController.cs')) &&
                fs.unlinkSync(path_1.join(path, 'Controllers', 'AuthController.cs')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Controllers', 'ApplicationRolesController.cs')) &&
                fs.unlinkSync(path_1.join(path, 'Controllers', 'ApplicationRolesController.cs')),
            !application.security &&
                fs.existsSync(path_1.join(path, 'Controllers', 'ApplicationUsersController.cs')) &&
                fs.unlinkSync(path_1.join(path, 'Controllers', 'ApplicationUsersController.cs'))
        ].concat(models, controllers, contexts, [
            writeServerTemplate(application, path_1.join(path, 'Data', 'OutputFormatter.cs'), 'OutputFormatter.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Data', 'CsvDataContractSerializerOutputFormatter.cs'), 'CsvDataContractSerializerOutputFormatter.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Data', 'XlsDataContractSerializerOutputFormatter.cs'), 'XlsDataContractSerializerOutputFormatter.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Data', 'EntityPatch.cs'), 'EntityPatch.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'HomeController.cs'), 'HomeController.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'ReportController.cs'), 'ReportController.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Views', 'Home', 'Index.cshtml'), 'Index.cshtml.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(path, 'Data', getPathByLanguage(application, 'DateMaterializerSource.cs'))),
            application.security
                ? outputServerSecurity(path, application, odataDataSources, mode, options, ignore)
                : Promise.resolve(true),
            outputStartup(path, application, odataDataSources, mode, ignore),
            outputProgram(path, application, mode, ignore),
            writeServerTemplate(application, path_1.join(path, 'appsettings.json'), 'appsettings.json.ejs', {
                application: application,
                dataSources: odataDataSources,
                appPath: appPath,
                getConnectionString: getConnectionString,
                dataSourceName: dataSourceName
            }, ignore, true),
            outputProjectFile(path, application, odataDataSources, mode, ignore),
            writeServerTemplate(application, path_1.join(path, 'web.config'), 'web.config.ejs', {
                application: application,
                serverVersion: application.serverVersion
            }, ignore, true),
            env.isDotNet2(application) &&
                mode != 'deploy' &&
                writeServerTemplateOnce(application, path_1.join(appPath, 'application.sln'), 'application.sln.ejs', {
                    application: application
                }, ignore),
            env.isDotNet2(application) &&
                writeServerTemplateOnce(application, path_1.join(path, 'Controllers', 'ServerMethodsController.cs'), 'ServerMethodsController.cs.ejs', { application: application }, ignore),
            env.isDotNet2(application) &&
                mode != 'deploy' &&
                copy(path_1.join(path, 'Properties'), getServerTemplate(application, 'launchSettings.json'), ignore, isRunning)
        ]));
    }
    else if (Application_1.isActiveDirectory(application.security)) {
        fs_1.ensure(path);
        fs_1.ensure(path_1.join(path, 'Models'));
        return Promise.all([
            application.security
                ? outputServerSecurity(path, application, odataDataSources, mode, options, ignore)
                : Promise.resolve(true),
            outputStartup(path, application, odataDataSources, mode, ignore),
            outputProgram(path, application, mode, ignore),
            writeServerTemplate(application, path_1.join(path, 'appsettings.json'), 'appsettings.json.ejs', {
                application: application,
                dataSources: odataDataSources,
                appPath: appPath,
                getConnectionString: getConnectionString,
                dataSourceName: dataSourceName
            }, ignore, true),
            outputProjectFile(path, application, odataDataSources, mode, ignore),
            writeServerTemplate(application, path_1.join(path, 'web.config'), 'web.config.ejs', {
                application: application,
                serverVersion: application.serverVersion
            }, ignore, true),
            env.isDotNet2(application) &&
                mode != 'deploy' &&
                writeServerTemplateOnce(application, path_1.join(appPath, 'application.sln'), 'application.sln.ejs', {
                    application: application
                }, ignore),
            env.isDotNet2(application) &&
                mode != 'deploy' &&
                copy(path_1.join(path, 'Properties'), getServerTemplate(application, 'launchSettings.json'), ignore, isRunning)
        ]);
    }
}
function outputProjectFile(path, application, dataSources, mode, ignore) {
    var proj = env.isDotNet2(application) && application.serverLang == 'vb'
        ? 'project.vbproj'
        : 'project.csproj';
    var targetPath = path_1.join(path, proj);
    if (ignore(targetPath)) {
        return;
    }
    return fs_1.fileExists(targetPath)
        .then(function (exists) {
        if (exists) {
            return fs_1.readFile(targetPath);
        }
        else {
            return '';
        }
    })
        .then(function (targetXML) {
        return renderTemplate_1.renderTemplate(getServerTemplate(application, proj + ".ejs"), {
            application: application,
            dataSources: dataSources,
            mode: mode
        }).then(function (sourceXML) { return merge_project_1.mergeProject(sourceXML, targetXML); });
    })
        .then(function (xml) { return fs_1.writeFile(targetPath, xml); });
}
function outputPackageJSON(path, application, dataSources, ignore) {
    var targetPath = path_1.join(path, 'package.json');
    if (ignore(targetPath)) {
        return;
    }
    return fs_1.fileExists(targetPath)
        .then(function (exists) { return (exists ? fs_1.readFile(targetPath) : ''); })
        .then(function (targetPackage) {
        return renderTemplate_1.renderTemplate('package.json.ejs', {
            application: application,
            dataSources: dataSources
        }).then(function (sourcePackage) {
            return merge_package_1.mergePackage(sourcePackage, targetPackage);
        });
    })
        .then(function (packageJSON) { return fs_1.writeFile(targetPath, packageJSON); });
}
function outputServerSecurity(path, application, dataSources, mode, options, ignore) {
    var authenticationPath = path_1.join(path, 'Authentication');
    fs_1.ensure(authenticationPath);
    var roles = lodash_1.uniq(lodash_1.flatten(application.pages.map(function (page) { return page.access; })).filter(function (access) { return access != 'Everybody' && access != 'Authenticated'; }));
    var securityDataSource = (dataSources || []).find(function (d) { return d.name == application.security.dataSource; });
    if (Application_1.isDefault(application.security)) {
        return Promise.all([
            outputIdentityMigrations(path, application, securityDataSource, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'TokenProviderOptions.cs'), 'TokenProviderOptions.cs.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderMiddleware.cs'))),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderAppBuilderExtensions.cs'))),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationPrincipalFactory.cs'), 'ApplicationPrincipalFactory.cs.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'Bootstrapper.cs'))),
            writeServerTemplate(application, path_1.join(path, 'Models', 'ApplicationUser.cs'), 'ApplicationUser.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Data', 'ApplicationIdentityDbContext.cs'), 'ApplicationIdentityDbContext.cs.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(path, 'Controllers', getPathByLanguage(application, 'RolesController.cs'))),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'ApplicationRolesController.cs'), 'ApplicationRolesController.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'AuthController.cs'), 'AuthController.cs.ejs', { application: application, roles: roles, mode: mode, options: options }, ignore),
            fs_1.rm(path_1.join(path, 'Controllers', getPathByLanguage(application, 'UsersController.cs'))),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'ApplicationUsersController.cs'), 'ApplicationUsersController.cs.ejs', { application: application }, ignore)
        ]);
    }
    if (Application_1.isActiveDirectory(application.security)) {
        return Promise.all([
            writeServerTemplate(application, path_1.join(authenticationPath, 'TokenProviderOptions.cs'), 'TokenProviderOptions.cs.ejs', { application: application }, ignore),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderMiddleware.cs'))),
            fs_1.rm(path_1.join(authenticationPath, getPathByLanguage(application, 'TokenProviderAppBuilderExtensions.cs'))),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserManager.cs'), 'ApplicationUserManager.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserManagerOptions.cs'), 'ApplicationUserManagerOptions.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationUserStore.cs'), 'ApplicationUserStore.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationRoleStore.cs'), 'ApplicationRoleStore.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(authenticationPath, 'ApplicationPrincipalFactory.cs'), 'ApplicationPrincipalFactory.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Models', 'ApplicationUser.cs'), 'ApplicationUser.cs.ejs', { application: application }, ignore),
            writeServerTemplate(application, path_1.join(path, 'Controllers', 'AuthController.cs'), 'AuthController.cs.ejs', { application: application, roles: roles, mode: mode }, ignore)
        ]);
    }
}
function outputIdentityMigrations(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Data', 'Migrations');
    fs_1.ensure(path);
    return Promise.all([
        writeTemplateUnlessContains(application, path_1.join(path, 'IdentityModelSnapshot.cs'), getServerTemplate(application, application.serverVersion == '3'
            ? 'IdentityModelSnapshot3.cs.ejs'
            : 'IdentityModelSnapshot.cs.ejs'), 'ApplicationUser', { application: application, dataSource: dataSource }, ignore),
        writeServerTemplate(application, path_1.join(path, '00000000000000_CreateIdentitySchema.cs'), application.serverVersion == '3'
            ? '00000000000000_CreateIdentitySchema3.cs.ejs'
            : '00000000000000_CreateIdentitySchema.cs.ejs', { application: application, dataSource: dataSource }, ignore),
        writeServerTemplate(application, path_1.join(path, '00000000000000_CreateIdentitySchema.Designer.cs'), application.serverVersion == '3'
            ? '00000000000000_CreateIdentitySchema3.Designer.cs.ejs'
            : '00000000000000_CreateIdentitySchema.Designer.cs.ejs', { application: application, dataSource: dataSource }, ignore)
    ]);
}
function outputStartup(path, application, dataSources, mode, ignore) {
    return writeServerTemplate(application, path_1.join(path, 'Startup.cs'), 'startup.cs.ejs', {
        dataSources: dataSources,
        application: application.name,
        security: application.security,
        localization: application.localization,
        serverVersion: application.serverVersion,
        mode: mode,
        dataSourceName: dataSourceName
    }, ignore);
}
function outputProgram(path, application, mode, ignore) {
    return writeServerTemplate(application, path_1.join(path, 'Program.cs'), 'program.cs.ejs', {
        application: application,
        mode: mode,
        serverVersion: application.serverVersion
    }, ignore);
}
function outputODataModels(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Models', dataSource.name);
    fs_1.ensure(path);
    return Promise.all(dataSource.schemas
        .filter(function (m) { return env.validModel(m); })
        .map(function (schema) {
        return outputODataModel(path, application, schema, dataSource, ignore);
    }));
}
function outputODataControllers(path, application, dataSource, ignore) {
    path = path_1.join(path, 'Controllers', dataSource.name);
    fs_1.ensure(path);
    return Promise.all(dataSource.schemas
        .filter(env.validModel)
        .map(function (schema) {
        return outputODataController(path, application, schema, dataSource, ignore);
    }));
}
function outputODataModel(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.name + ".cs"), 'model.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource
    }, ignore);
}
function deleteODataModel(path, model, ext, ignore) {
    return safeDelete(path_1.join(path_1.join(path, model.name + "." + ext)), ignore);
}
function deleteODataController(path, model, ext, ignore) {
    return safeDelete(path_1.join(path, model.entitySet + "Controller." + ext), ignore);
}
function safeDelete(path, ignore) {
    if (!ignore(path)) {
        return fs_1.rm(path);
    }
}
function outputODataController(path, application, model, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, model.entitySet + "Controller.cs"), 'controller.cs.ejs', {
        model: model,
        application: application.name,
        dataSource: dataSource,
        serverVersion: application.serverVersion
    }, ignore);
}
function outputODataContext(path, application, dataSource, ignore) {
    return writeServerTemplate(application, path_1.join(path, 'Data', env.type(dataSource.name) + "Context.cs"), 'context.cs.ejs', {
        dataSource: dataSource,
        application: application
    }, ignore);
}
function designTimeHtml(application) {
    return renderTemplate_1.renderTemplate('app.component.html.ejs', Object.assign({ security: null }, application));
}
exports.designTimeHtml = designTimeHtml;
function setPageTitle(contentDocument, title) {
    contentDocument.querySelector('#title').innerHTML = title;
}
exports.setPageTitle = setPageTitle;
function setLogo(contentDocument, path, application) {
    if (application.logo) {
        var logo = contentDocument.querySelector('#logo img');
        var src = path_1.join(path, 'client', 'src', application.logo);
        logo.src = "file://" + src;
    }
}
exports.setLogo = setLogo;
function navigationContainerElement(contentDocument) {
    return contentDocument.querySelector('#navigation');
}
exports.navigationContainerElement = navigationContainerElement;
function contentElements(contentDocument) {
    return contentDocument.querySelectorAll('#content');
}
exports.contentElements = contentElements;
function copy(path, file, ignore, isRunning) {
    if (isRunning === void 0) { isRunning = false; }
    return copyFile(path, file, path_1.basename(file), ignore, isRunning);
}
function copyUnlessContains(path, file, value) {
    var templates = path_1.join(__dirname, './templates');
    var dest = path_1.join(path, path_1.basename(file));
    return fs_1.fileExists(dest)
        .then(function (exists) {
        if (exists) {
            // File exists - check if it contains the required value and overwrite otherwise.
            return fs_1.readFile(dest).then(function (contents) { return contents.indexOf(value) < 0; });
        }
        else {
            // File does not exist - create it.
            return true;
        }
    })
        .then(function (write) {
        if (write) {
            return new Promise(function (resolve, reject) {
                var reader = fs.createReadStream(path_1.join(templates, file));
                reader.on('error', reject);
                var writer = fs.createWriteStream(dest);
                writer.on('error', reject);
                reader.pipe(writer);
                resolve();
            });
        }
    });
}
function copyFile(path, file, target, ignore, isRunning) {
    if (isRunning === void 0) { isRunning = false; }
    var templates = path_1.join(__dirname, './templates');
    var dest = path_1.join(path, target);
    if (ignore(dest)) {
        return;
    }
    return fs_1.fileExists(dest)
        .then(function (exists) {
        return !(isRunning && exists);
    })
        .then(function (write) {
        if (write) {
            return new Promise(function (resolve, reject) {
                var reader = fs.createReadStream(path_1.join(templates, file));
                reader.on('error', reject);
                var writer = fs.createWriteStream(dest);
                writer.on('error', reject);
                reader.pipe(writer);
                resolve();
            });
        }
    });
}
function copyFileOnce(path, file, target, ignore) {
    return copyFile(path, file, target, ignore, true);
}
function deleteDataSource(path, name, swagger, application) {
    var ignore = createIgnore(path, application);
    var clientPath = path_1.join(path, 'client', 'src', 'app');
    var serverPath = path_1.join(path, 'server');
    var filename = env.file(name);
    var dataSource = DataSource_1.swaggerToDataSource(swagger, false);
    var models = dataSource.schemas.filter(env.validModel);
    var controllersPath = path_1.join(serverPath, 'Controllers', name);
    var deleteControllers = models.map(function (model) {
        return deleteODataController(controllersPath, model, 'cs', ignore);
    });
    var deleteVBControllers = models.map(function (model) {
        return deleteODataController(controllersPath, model, 'vb', ignore);
    });
    var modelsPath = path_1.join(serverPath, 'Models', name);
    var deleteModels = models.map(function (model) {
        return deleteODataModel(modelsPath, model, 'cs', ignore);
    });
    var deleteVBModels = models.map(function (model) {
        return deleteODataModel(modelsPath, model, 'vb', ignore);
    });
    return Promise.all([
        safeDelete(path_1.join(clientPath, filename + ".model.ts"), ignore),
        safeDelete(path_1.join(clientPath, filename + ".service.ts"), ignore),
        safeDelete(path_1.join(clientPath, filename + "-auth.service.ts"), ignore),
        safeDelete(path_1.join(clientPath, filename + "-auth.interceptor.ts"), ignore)
    ].concat(deleteModels, deleteVBModels, deleteControllers, deleteVBControllers, [
        safeDelete(path_1.join(serverPath, 'Data', filename.split('-').join('') + "Context.cs"), ignore),
        safeDelete(path_1.join(serverPath, 'Data', filename.split('-').join('') + "Context.vb"), ignore),
        fs_1.dirExists(controllersPath).then(function (r) {
            return r &&
                fs_1.readdir(controllersPath).then(function (r) { return !r.length && fs_1.rm(controllersPath); });
        }),
        fs_1.dirExists(modelsPath).then(function (r) { return r && fs_1.readdir(modelsPath).then(function (r) { return !r.length && fs_1.rm(modelsPath); }); })
    ]));
}
exports.deleteDataSource = deleteDataSource;
function deletePage(path, name) {
    return fs_1.rm(path_1.join(path, 'client', 'src', 'app', env.file(name)));
}
exports.deletePage = deletePage;
function renamePage(path, from, to) {
    var components = path_1.join(path, 'client', 'src', 'app');
    var fromFile = env.file(from);
    var fromDir = path_1.join(components, fromFile);
    var toFile = env.file(to);
    var toDir = path_1.join(components, toFile);
    return (fs.existsSync(fromDir) &&
        fs_1.rename(fromDir, toDir).then(function () {
            var fromFilePath = path_1.join(toDir, fromFile + ".component.ts");
            if (fs.existsSync(fromFilePath)) {
                return fs_1.readFile(fromFilePath)
                    .then(function (text) {
                    var fromType = "" + env.type(from);
                    var toType = "" + env.type(to);
                    text = text
                        .replace(new RegExp(fromType + "Generated", 'g'), toType + "Generated")
                        .replace(new RegExp(fromType + "Component", 'g'), toType + "Component")
                        .replace(new RegExp("" + fromFile, 'g'), "" + toFile);
                    return fs_1.writeFile(fromFilePath, text, 'utf8');
                })
                    .then(function () {
                    return Promise.all([
                        fs_1.rename(fromFilePath, path_1.join(toDir, toFile + ".component.ts")),
                        fs_1.rename(path_1.join(toDir, fromFile + "-generated.component.ts"), path_1.join(toDir, toFile + "-generated.component.ts")),
                        fs_1.rename(path_1.join(toDir, fromFile + ".component.html"), path_1.join(toDir, toFile + ".component.html"))
                    ]);
                });
            }
        }));
}
exports.renamePage = renamePage;
function outputPages(path, application, pages, dataSources, options, ignore) {
    return Promise.all(pages.map(function (page) {
        return outputPage(path, application, page, dataSources, options, ignore);
    }));
}
function outputLayouts(path, application, layouts, dataSources, options, ignore) {
    return Promise.all(layouts.map(function (layout) {
        return outputLayout(path, application, layout, dataSources, options, ignore);
    }));
}
function outputPage(path, application, page, dataSources, options, ignore) {
    return writePage(fs_1.ensure(path_1.join(path, env.file(page.name))), application, page, dataSources, options, ignore);
}
function outputLayout(path, application, layout, dataSources, options, ignore) {
    var page = __assign({}, layout, { name: layout.name + 'Layout' });
    return writePage(fs_1.ensure(path_1.join(path, env.file(page.name))), application, page, dataSources, options, ignore, true);
}
function traverse(events, callback) {
    function descend(actions) {
        return actions.reduce(function (result, action) {
            callback(result, action, descend);
            return result;
        }, []);
    }
    if (!events) {
        return [];
    }
    var actions = Object.keys(events).reduce(function (actions, key) {
        actions.push.apply(actions, events[key]);
        return actions;
    }, []);
    return descend(actions);
}
function setterNames(events) {
    function callback(result, action, traverse) {
        if (Event_1.isSet(action)) {
            result.push(action.name);
        }
        else {
            if (action.then) {
                result.push.apply(result, traverse(action.then));
            }
            if (action.error) {
                result.push.apply(result, traverse(action.error));
            }
        }
    }
    return traverse(events, callback);
}
function serviceNames(events) {
    function callback(result, action, traverse) {
        if (Event_1.isInvoke(action) || Event_1.isExport(action)) {
            if (action.name && action.name.includes('.')) {
                var service = action.name.split('.')[0];
                if (service != 'Security') {
                    result.push(service);
                }
            }
        }
        if (action.then) {
            result.push.apply(result, traverse(action.then));
        }
        if (action.error) {
            result.push.apply(result, traverse(action.error));
        }
    }
    return traverse(events, callback);
}
function dialogs(page) {
    var dialogs = [];
    function callback(result, action, traverse) {
        if (Event_1.isPopup(action)) {
            if (dialogs.indexOf(action.path) < 0) {
                dialogs.push(action.path);
            }
        }
        else {
            if (action.then) {
                traverse(action.then);
            }
            if (action.error) {
                traverse(action.error);
            }
        }
    }
    var events = Object.assign({}, page.events);
    traverseComponents(page, function (component) {
        if (component.events) {
            lodash_1.forEach(component.events, function (actions, name) {
                events[name] = actions.concat(events[name] || []);
            });
        }
    });
    traverse(events, callback);
    return dialogs;
}
function pageParameters(pages) {
    var parameters = {};
    function callback(result, action, traverse) {
        if ((Event_1.isPopup(action) || Event_1.isNavigate(action)) && action.parameters) {
            parameters[action.path] = action.parameters.map(function (parameter) { return parameter.name; });
        }
        else {
            if (action.then) {
                traverse(action.then);
            }
            if (action.error) {
                traverse(action.error);
            }
        }
    }
    pages.forEach(function (page) {
        var events = Object.assign({}, page.events);
        traverseComponents(page, function (component) {
            if (component.events) {
                lodash_1.forEach(component.events, function (actions, name) {
                    events[name] = actions.concat(events[name] || []);
                });
            }
            else if (component.type == 'link') {
                if (Array.isArray(component.parameters)) {
                    parameters[component.path] = component.parameters.map(function (parameter) { return parameter.name; });
                }
            }
        }, true);
        traverse(events, callback);
    });
    return parameters;
}
exports.pageParameters = pageParameters;
function allComponents(application, page, properties, options) {
    var components = [];
    var types = {};
    function collect(component) {
        var _a = component.components, children = _a === void 0 ? [] : _a, _b = component.template, template = _b === void 0 ? [] : _b, _c = component.headerTemplate, headerTemplate = _c === void 0 ? [] : _c, _d = component.editTemplate, editTemplate = _d === void 0 ? [] : _d, _e = component.footerTemplate, footerTemplate = _e === void 0 ? [] : _e;
        components.push(component);
        children.forEach(collect);
        if (Array.isArray(template)) {
            template.forEach(collect);
        }
        if (Array.isArray(headerTemplate)) {
            headerTemplate.forEach(collect);
        }
        if (Array.isArray(footerTemplate)) {
            footerTemplate.forEach(collect);
        }
        if (Array.isArray(editTemplate)) {
            editTemplate.forEach(collect);
        }
    }
    page.components.forEach(function (component) {
        var prepared = Component_1.prepareComponent(application, properties, Object.assign({ root: true }, component), options, function (component) {
            var componentsOfType = types[component.type] || 0;
            componentsOfType++;
            types[component.type] = componentsOfType;
            return componentsOfType;
        });
        collect(prepared);
    });
    return components;
}
function traverseComponents(parent, callback, includeTemplateComponents) {
    if (includeTemplateComponents === void 0) { includeTemplateComponents = false; }
    var _a = parent.components, components = _a === void 0 ? [] : _a, _b = parent.template, template = _b === void 0 ? [] : _b, _c = parent.editTemplate, editTemplate = _c === void 0 ? [] : _c;
    components
        .concat(template)
        .concat(editTemplate)
        .forEach(function (component) {
        callback(component);
        Object.keys(component).forEach(function (key) {
            var value = component[key];
            if (value != null &&
                (includeTemplateComponents || key != 'components')) {
                if (Array.isArray(value)) {
                    value.forEach(function (i) { return traverseComponents(i, callback); });
                }
                else {
                    traverseComponents(value, callback);
                }
            }
        });
        traverseComponents(component, callback);
    });
}
function propertiesAndServices(page) {
    var properties = setterNames(page.events).concat('parameters', 'locale');
    var services = serviceNames(page.events);
    traverseComponents(page, function (component) {
        if (component.events) {
            properties.push.apply(properties, setterNames(component.events));
            services.push.apply(services, serviceNames(component.events));
        }
    });
    return {
        properties: lodash_1.uniq(properties),
        services: lodash_1.uniq(services)
    };
}
function writePage(path, application, page, dataSources, options, ignore, isLayout) {
    if (isLayout === void 0) { isLayout = false; }
    var _a = propertiesAndServices(page), services = _a.services, properties = _a.properties;
    if (application.security) {
        services.push('Security');
    }
    var components = allComponents(application, page, properties, options);
    var events = Object.keys(page.events || {}).map(function (name) {
        return {
            name: name,
            value: name,
            actions: page.events[name]
        };
    });
    var data = {
        isLayout: isLayout,
        name: page.name,
        access: page.access || [],
        events: events,
        dataSources: application.security
            ? dataSources.concat(DataSource_1.swaggerToDataSource(securityDataSource_1.securityDataSource(), application.https))
            : dataSources,
        properties: properties,
        security: application.security,
        services: services,
        members: properties.concat(services.map(env.variable)),
        componentTypes: lodash_1.uniq(components
            .filter(function (component) { return component.name; })
            .map(function (component) { return component.type; })).filter(env.isAngularComponent),
        components: components.filter(function (component) { return component.root === true; }),
        allComponents: components,
        dialogs: dialogs(page),
        application: application,
        options: options
    };
    var filename = env.file(page.name);
    var promises = [
        writeTemplate(path_1.join(path, filename + "-generated.component.ts"), 'page.generated.ts.ejs', data, ignore),
        writeTemplate(path_1.join(path, filename + ".component.html"), 'page.html.ejs', data, ignore)
    ];
    if (!fs.existsSync(path_1.join(path, filename + ".component.ts"))) {
        promises.push(writeTemplate(path_1.join(path, filename + ".component.ts"), 'page.ts.ejs', data, ignore));
    }
    return Promise.all(promises);
}
function outputDataSources(path, application, services, ignore) {
    fs_1.ensure(path);
    var odata = services.some(function (service) { return service.type == 'odata'; });
    return Promise.all([
        odata || application.security
            ? copyFile(path, 'odata-client.ts.ejs', 'odata-client.ts', ignore)
            : Promise.resolve(true)
    ].concat(services.map(function (service) {
        return outputService(path, application, service, ignore);
    })));
}
function removeSecurity(path) {
    return Promise.all([
        fs_1.rm(path_1.join(path, 'security.service.ts')),
        fs_1.rm(path_1.join(path, 'security.interceptor.ts')),
        fs_1.rm(path_1.join(path, '*.guard.ts'))
    ]);
}
function outputClientSecurity(path, application, pages, dataSources, ignore) {
    return Promise.all([
        fs_1.rm(path_1.join(path, '*.guard.ts')),
        fs_1.rm(path_1.join(path, 'unauthorized.component.*')),
        writeTemplate(path_1.join(path, 'security.service.ts'), 'security.service.ts.ejs', application, ignore),
        writeTemplate(path_1.join(path, 'security.interceptor.ts'), 'security.interceptor.ts.ejs', {
            dataSources: dataSources
        }, ignore),
        writeTemplate(path_1.join(path, 'auth.guard.ts'), 'auth.guard.ts.ejs', application, ignore)
    ]);
}
function outputService(path, application, service, ignore) {
    return Promise.all([
        writeModels(path, service, ignore),
        writeService(path, application, service, ignore),
        writeAuth(path, service, ignore)
    ]);
}
function writeAppModule(path, application, dataSources, serverDataSourceNames, pages, layouts, ignore) {
    return Promise.all([
        copyUnlessContains(path, 'app.module.ts', 'app.module-generated'),
        writeTemplate(path_1.join(path, 'app.module-generated.ts'), 'app.module-generated.ts.ejs', {
            theme: application.theme,
            application: application,
            serverDataSourceNames: serverDataSourceNames,
            dataSources: dataSources,
            componentTypes: env.componentTypes(layouts, pages),
            pages: pages,
            layouts: layouts
        }, ignore)
    ]);
}
function writeAuth(path, service, ignore) {
    if (service.authorization) {
        if (service.authorization.type == 'oauth' ||
            service.authorization.type == 'oauth2') {
            return Promise.all([
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.service.ts"), 'oauth.service.ts.ejs', service, ignore),
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.interceptor.ts"), 'oauth.interceptor.ts.ejs', service, ignore)
            ]);
        }
        else if (service.authorization.type == 'apiKey') {
            return writeTemplate(path_1.join(path, env.file(service.name) + "-auth.interceptor.ts"), 'api-key.interceptor.ts.ejs', service, ignore);
        }
        else if (service.authorization.type == 'azuread') {
            return Promise.all([
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.service.ts"), 'azuread.service.ts.ejs', service, ignore),
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.interceptor.ts"), 'azuread.interceptor.ts.ejs', service, ignore)
            ]);
        }
        else if (service.authorization.type == 'basic') {
            return Promise.all([
                fs_1.rm(path_1.join(path, env.file(service.name) + "-basic-auth.service.ts")),
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.service.ts"), 'http-basic.service.ts.ejs', service, ignore),
                writeTemplate(path_1.join(path, env.file(service.name) + "-auth.interceptor.ts"), 'http-basic.interceptor.ts.ejs', service, ignore)
            ]);
        }
    }
}
function writeService(path, application, service, ignore) {
    return writeTemplate(path_1.join(path, env.file(service.name) + ".service.ts"), 'service.ts.ejs', Object.assign({ security: application.security }, service), ignore);
}
function writeModels(path, service, ignore) {
    return writeTemplate(path_1.join(path, env.file(service.name) + ".model.ts"), 'model.ts.ejs', service, ignore);
}
function writeTemplate(path, template, data, ignore) {
    if (ignore(path)) {
        return;
    }
    return renderTemplate_1.renderTemplate(template, data).then(function (output) {
        return updateFile(path, output);
    });
}
function writeTemplateUnlessContains(application, path, template, value, data, ignore) {
    path = getPathByLanguage(application, path);
    return fs_1.fileExists(path)
        .then(function (exists) {
        if (exists) {
            // File exists - check if it contains the required value and overwrite otherwise.
            return fs_1.readFile(path).then(function (contents) { return contents.indexOf(value) < 0; });
        }
        else {
            // File does not exist - create it.
            return true;
        }
    })
        .then(function (write) {
        if (write) {
            return writeTemplate(path, template, data, ignore);
        }
    });
}
function writeTemplateOnce(path, template, data, ignore) {
    return fs_1.fileExists(path).then(function (exists) {
        if (!exists) {
            return writeTemplate(path, template, data, ignore);
        }
    });
}
function writeFileOnce(path, data, ignore, options) {
    if (ignore(path)) {
        return;
    }
    return fs_1.fileExists(path).then(function (exists) {
        if (!exists) {
            return fs_1.writeFile(path, data, options);
        }
    });
}
//# sourceMappingURL=index.js.map