"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var accordion_1 = require("primeng/accordion");
var AccordionItemComponent = /** @class */ (function () {
    function AccordionItemComponent() {
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], AccordionItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], AccordionItemComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], AccordionItemComponent.prototype, "selected", void 0);
    __decorate([
        core_1.ViewChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], AccordionItemComponent.prototype, "template", void 0);
    AccordionItemComponent = __decorate([
        core_1.Component({
            selector: 'rz-accordion-item',
            template: "\n    <ng-template><ng-content></ng-content></ng-template>\n  "
        })
    ], AccordionItemComponent);
    return AccordionItemComponent;
}());
exports.AccordionItemComponent = AccordionItemComponent;
var AccordionComponent = /** @class */ (function () {
    function AccordionComponent() {
        this.multiple = false;
        this.style = {};
        this.expand = new core_1.EventEmitter();
        this.collapse = new core_1.EventEmitter();
    }
    AccordionComponent.prototype.onOpen = function (event) {
        this.expand.next({
            index: event.index
        });
    };
    AccordionComponent.prototype.onClose = function (event) {
        this.collapse.next({
            index: event.index
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], AccordionComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], AccordionComponent.prototype, "selectedIndex", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], AccordionComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AccordionComponent.prototype, "expand", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AccordionComponent.prototype, "collapse", void 0);
    __decorate([
        core_1.ContentChildren(AccordionItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], AccordionComponent.prototype, "items", void 0);
    AccordionComponent = __decorate([
        core_1.Component({
            selector: 'rz-accordion',
            template: "<p-accordion (onClose)=\"onClose($event)\" (onOpen)=\"onOpen($event)\" [style]=\"style\" [multiple]=\"multiple\">\n    <p-accordionTab *ngFor=\"let item of items; let index = index\" [header]=\"item.icon ? null : item.text\" [selected]=\"item.selected || index == selectedIndex\">\n      <p-header *ngIf=\"item.icon\">\n        <i class=\"material-icons\">{{item.icon}}</i><span class=\"material-icons-label\">{{item.text}}</span>\n      </p-header>\n      <ng-container *ngTemplateOutlet=\"item.template\"></ng-container>\n    </p-accordionTab>\n  </p-accordion>"
        })
    ], AccordionComponent);
    return AccordionComponent;
}());
exports.AccordionComponent = AccordionComponent;
var AccordionModule = /** @class */ (function () {
    function AccordionModule() {
    }
    AccordionModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, accordion_1.AccordionModule],
            declarations: [AccordionComponent, AccordionItemComponent],
            exports: [AccordionComponent, AccordionItemComponent]
        })
    ], AccordionModule);
    return AccordionModule;
}());
exports.AccordionModule = AccordionModule;
