"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var calendar_1 = require("primeng/calendar");
var form_field_1 = require("./form-field");
var dates_1 = require("./dates");
var DateFormFieldComponent = /** @class */ (function (_super) {
    __extends(DateFormFieldComponent, _super);
    function DateFormFieldComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.utc = true;
        _this.showTime = false;
        _this.timeOnly = false;
        _this.inline = false;
        _this.showSeconds = false;
        _this.dateFormat = 'mm/dd/yy';
        _this.hourFormat = '24';
        _this.yearRange = '1950:2050';
        _this.localeSettings = dates_1.defaultLocaleSettings();
        return _this;
    }
    DateFormFieldComponent_1 = DateFormFieldComponent;
    Object.defineProperty(DateFormFieldComponent.prototype, "locale", {
        set: function (locale) {
            this.localeSettings = dates_1.toLocaleSettings(locale);
        },
        enumerable: true,
        configurable: true
    });
    DateFormFieldComponent.prototype.parse = function (value) {
        return dates_1.parse(value, this.utc);
    };
    DateFormFieldComponent.prototype.ngAfterContentInit = function () {
        if (this.calendar) {
            this.calendar.onUserInput = dates_1.onUserInput;
        }
    };
    var DateFormFieldComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "utc", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "showTime", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "timeOnly", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "inline", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "showSeconds", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "dateFormat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "hourFormat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DateFormFieldComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "yearRange", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], DateFormFieldComponent.prototype, "locale", null);
    __decorate([
        core_1.ViewChild(calendar_1.Calendar),
        __metadata("design:type", Object)
    ], DateFormFieldComponent.prototype, "calendar", void 0);
    DateFormFieldComponent = DateFormFieldComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-date-form-field',
            template: "\n    <p-calendar\n      appendTo=\"body\"\n      [styleClass]=\"disabled ? 'ui-state-disabled' : null\"\n      [dateFormat]=\"dateFormat\"\n      [showIcon]=\"true\"\n      [timeOnly]=\"timeOnly\"\n      [hourFormat]=\"hourFormat\"\n      [inline]=\"inline\"\n      [formControl]=\"control\"\n      [locale]=\"localeSettings\"\n      [placeholder]=\"placeholder\"\n      [showTime]=\"showTime\"\n      [showSeconds]=\"showSeconds\"\n      [yearNavigator]=\"true\"\n      [yearRange]=\"yearRange\"\n      [monthNavigator]=\"true\"\n      [inputId]=\"property\"\n    >\n    </p-calendar>\n    <div\n      class=\"md-inputfield\"\n      *ngIf=\"(control.touched || submitted) && control.errors?.required\"\n    >\n      <div class=\"ui-message ui-messages-error ui-corner-all\">\n        {{ title }} {{ requiredText }}\n      </div>\n    </div>\n  ",
            providers: [
                {
                    provide: form_field_1.FormFieldComponent,
                    useExisting: core_1.forwardRef(function () { return DateFormFieldComponent_1; })
                }
            ]
        })
    ], DateFormFieldComponent);
    return DateFormFieldComponent;
}(form_field_1.FormFieldComponent));
exports.DateFormFieldComponent = DateFormFieldComponent;
