"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var dialog_1 = require("primeng/dialog");
var DialogRef = /** @class */ (function () {
    function DialogRef(router) {
        var _this = this;
        this.afterClosed$ = new rxjs_1.Subject();
        this.beforeClose$ = new rxjs_1.Subject();
        this.subscription = router.events.subscribe(function () {
            _this.close(null);
        });
    }
    DialogRef.prototype.afterClosed = function () {
        return this.afterClosed$.asObservable();
    };
    DialogRef.prototype.beforeClose = function () {
        return this.beforeClose$.asObservable();
    };
    DialogRef.prototype.close = function (result) {
        var _this = this;
        if (result === void 0) { result = null; }
        var subject = new rxjs_1.Subject();
        subject.subscribe(function () {
            _this.afterClosed$.next(result);
            _this.afterClosed$.complete();
            _this.subscription.unsubscribe();
            subject.complete();
        });
        this.beforeClose$.next(subject);
        this.beforeClose$.complete();
    };
    DialogRef = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [router_1.Router])
    ], DialogRef);
    return DialogRef;
}());
exports.DialogRef = DialogRef;
var DialogComponent = /** @class */ (function () {
    function DialogComponent(dialogRef) {
        var _this = this;
        this.dialogRef = dialogRef;
        this.style = { width: '600px' };
        this.display = true;
        dialogRef.beforeClose().subscribe(function (close) {
            document.body.classList.remove('no-scroll');
            if (_this.visible == true) {
                _this.close$ = close;
                _this.visible = false;
            }
            else {
                close.next();
            }
        });
    }
    Object.defineProperty(DialogComponent.prototype, "width", {
        set: function (value) {
            if (value != null) {
                this.style.width = value + "px";
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DialogComponent.prototype, "height", {
        set: function (value) {
            if (value != null) {
                this.style.height = value + "px";
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DialogComponent.prototype, "visible", {
        get: function () {
            return this.display;
        },
        set: function (value) {
            this.display = value;
            if (this.visible == false) {
                if (this.close$) {
                    this.close$.next();
                }
                else {
                    this.dialogRef.close(null);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    DialogComponent.prototype.ngAfterViewChecked = function () {
        if (this.dialog && this.dialog.container && this.dialog.contentViewChild) {
            if (this.style.height) {
                var height = this.dialog.container.offsetHeight -
                    this.dialog.headerViewChild.nativeElement.offsetHeight;
                this.dialog.contentViewChild.nativeElement.style.height = height + "px";
            }
            else if (this.contentHeight !=
                this.dialog.contentViewChild.nativeElement.offsetHeight) {
                this.contentHeight = this.dialog.contentViewChild.nativeElement.offsetHeight;
                this.dialog.positionOverlay();
            }
        }
    };
    __decorate([
        core_1.ViewChild(dialog_1.Dialog),
        __metadata("design:type", dialog_1.Dialog)
    ], DialogComponent.prototype, "dialog", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_1.Type)
    ], DialogComponent.prototype, "component", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DialogComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], DialogComponent.prototype, "width", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], DialogComponent.prototype, "height", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DialogComponent.prototype, "left", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DialogComponent.prototype, "top", void 0);
    DialogComponent = __decorate([
        core_1.Component({
            selector: 'rz-dialog',
            template: "\n    <p-dialog\n      [style]=\"style\"\n      [(visible)]=\"visible\"\n      [header]=\"title\"\n      [focusOnShow]=\"false\"\n      [positionLeft]=\"left\"\n      [positionTop]=\"top\"\n      [modal]=\"true\"\n    >\n      <ng-container *ngComponentOutlet=\"component\"></ng-container>\n    </p-dialog>\n  "
        }),
        __metadata("design:paramtypes", [DialogRef])
    ], DialogComponent);
    return DialogComponent;
}());
exports.DialogComponent = DialogComponent;
var DialogInjector = /** @class */ (function () {
    function DialogInjector(injector, tokens) {
        this.injector = injector;
        this.tokens = tokens;
    }
    DialogInjector.prototype.get = function (token, notFoundValue) {
        var value = this.tokens.get(token);
        if (typeof value !== 'undefined') {
            return value;
        }
        return this.injector.get(token, notFoundValue);
    };
    return DialogInjector;
}());
exports.DialogInjector = DialogInjector;
exports.DIALOG_PARAMETERS = new core_1.InjectionToken('DialogParameters');
var DialogService = /** @class */ (function () {
    function DialogService(componentFactoryResolver, applicationRef, injector, router) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.router = router;
    }
    DialogService.prototype.open = function (componentType, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(DialogComponent);
        var dialogRef = new DialogRef(this.router);
        var injectionTokens = new WeakMap();
        injectionTokens.set(DialogRef, dialogRef);
        var parameters = options.parameters, rest = __rest(options, ["parameters"]);
        if (parameters) {
            injectionTokens.set(exports.DIALOG_PARAMETERS, parameters);
        }
        var componentRef = componentFactory.create(new DialogInjector(this.injector, injectionTokens));
        componentRef.instance.component = componentType;
        Object.assign(componentRef.instance, rest);
        this.applicationRef.attachView(componentRef.hostView);
        document.body.appendChild(componentRef.hostView.rootNodes[0]);
        document.body.classList.add('no-scroll');
        dialogRef.afterClosed().subscribe(function () {
            _this.applicationRef.detachView(componentRef.hostView);
            componentRef.destroy();
        });
        return dialogRef;
    };
    DialogService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver,
            core_1.ApplicationRef,
            core_1.Injector,
            router_1.Router])
    ], DialogService);
    return DialogService;
}());
exports.DialogService = DialogService;
var DialogModule = /** @class */ (function () {
    function DialogModule() {
    }
    DialogModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, dialog_1.DialogModule],
            providers: [DialogService],
            declarations: [DialogComponent],
            exports: [DialogComponent],
            entryComponents: [DialogComponent]
        })
    ], DialogModule);
    return DialogModule;
}());
exports.DialogModule = DialogModule;
if (/Android/.test(navigator.appVersion)) {
    window.addEventListener('resize', function () {
        var activeElement = document.activeElement;
        if (activeElement.tagName == 'INPUT' ||
            activeElement.tagName == 'TEXTAREA') {
            window.setTimeout(function () {
                activeElement.scrollIntoView();
            }, 0);
        }
    });
}
