import { SimpleChanges, EventEmitter, TemplateRef, QueryList } from '@angular/core';
import { SelectItem } from 'primeng/api';
import { InputComponent } from './template-form';
export declare class DropDownDataGridColumnTemplate {
    templateRef: TemplateRef<any>;
    constructor(templateRef: TemplateRef<any>);
}
export declare class DropDownDataGridColumn {
    private grid;
    constructor(grid: DropDownDataGridComponent);
    title: string;
    property: string;
    sortable: boolean;
    width: number | string;
    template: TemplateRef<any>;
    readonly style: any;
}
export declare class DropDownDataGridComponent extends InputComponent<any> {
    style: {};
    emptyText: string;
    textProperty: string;
    valueProperty: string;
    placeholder: string;
    data: any[];
    selectedValue: any;
    count: number;
    allowFiltering: boolean;
    allowSorting: boolean;
    multiple: boolean;
    columnWidth: string;
    isLoading: boolean;
    loadData: EventEmitter<any>;
    pageSize: number;
    value: any;
    columns: QueryList<DropDownDataGridColumn>;
    internalColumns: Array<{
        property: string;
        title: string;
        sortable: boolean;
    }>;
    readonly options: SelectItem[];
    loading: boolean;
    selection: any;
    searchValue: string;
    multiSortMeta: any[];
    private skip;
    private top;
    private filter;
    onToggle(op: any, dropdown: any, lookupPanel: any, event: any): void;
    optionByItem(item: any): {
        label: any;
        value: any;
    };
    updateValue(): void;
    onSearch(): void;
    onSearchKeyPress(event: any): void;
    onRowSelect(op: any, dropdown: any, event: any): void;
    onClose(op: any, dropdown: any, event: any): void;
    onPage(event: any): void;
    orderBy: string;
    onSort(event: any): void;
    callLoadData(): void;
    load(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
export declare class DropDownDataGridModule {
}
