"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var fieldset_1 = require("primeng/fieldset");
var FieldsetHeaderComponent = /** @class */ (function () {
    function FieldsetHeaderComponent() {
    }
    FieldsetHeaderComponent = __decorate([
        core_1.Component({
            selector: 'rz-fieldset-header',
            template: "\n    <ng-content></ng-content>\n  "
        })
    ], FieldsetHeaderComponent);
    return FieldsetHeaderComponent;
}());
exports.FieldsetHeaderComponent = FieldsetHeaderComponent;
var FieldsetComponent = /** @class */ (function () {
    function FieldsetComponent() {
        this.style = {};
        this.allowCollapse = false;
        this.collapsed = false;
        this.expand = new core_1.EventEmitter();
        this.collapse = new core_1.EventEmitter();
    }
    FieldsetComponent.prototype.onToggle = function (event) {
        if (event.collapsed) {
            this.collapse.next();
        }
        else {
            this.expand.next();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FieldsetComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FieldsetComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FieldsetComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FieldsetComponent.prototype, "allowCollapse", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FieldsetComponent.prototype, "collapsed", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FieldsetComponent.prototype, "expand", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FieldsetComponent.prototype, "collapse", void 0);
    FieldsetComponent = __decorate([
        core_1.Component({
            selector: 'rz-fieldset',
            template: "<p-fieldset (onAfterToggle)=\"onToggle($event)\" [collapsed]=\"collapsed\" [style]=\"style\" [toggleable]=\"allowCollapse\" [legend]=\"icon ? null : text\">\n    <p-header *ngIf=\"icon\">\n      <i class=\"material-icons\">{{icon}}</i><span class=\"material-icons-label\">{{text}}</span>\n    </p-header>\n    <p-header>\n      <ng-content select=\"rz-fieldset-header\"></ng-content>\n    </p-header>\n    <ng-content></ng-content>\n  </p-fieldset>"
        })
    ], FieldsetComponent);
    return FieldsetComponent;
}());
exports.FieldsetComponent = FieldsetComponent;
var FieldsetModule = /** @class */ (function () {
    function FieldsetModule() {
    }
    FieldsetModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, fieldset_1.FieldsetModule],
            declarations: [FieldsetComponent, FieldsetHeaderComponent],
            exports: [FieldsetComponent, FieldsetHeaderComponent]
        })
    ], FieldsetModule);
    return FieldsetModule;
}());
exports.FieldsetModule = FieldsetModule;
