"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var transition_1 = require("./transition");
var layout_1 = require("./layout");
var FooterComponent = /** @class */ (function () {
    function FooterComponent(layoutService) {
        this.layoutService = layoutService;
        this.style = {};
        this.fixed = true;
    }
    FooterComponent.prototype.ngAfterViewInit = function () {
        this.layoutService.footerHeight.next(this.fixed ? this.footer.nativeElement.offsetHeight : 0);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FooterComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FooterComponent.prototype, "fixed", void 0);
    __decorate([
        core_1.ViewChild('footer'),
        __metadata("design:type", core_1.ElementRef)
    ], FooterComponent.prototype, "footer", void 0);
    __decorate([
        core_1.ViewChild(layout_1.OffsetBySidebarDirective),
        __metadata("design:type", layout_1.OffsetBySidebarDirective)
    ], FooterComponent.prototype, "offset", void 0);
    FooterComponent = __decorate([
        core_1.Component({
            selector: 'rz-footer',
            template: "\n  <div class=\"footer\" [ngStyle]=\"style\" [ngClass]=\"{fixed:fixed}\" #footer rz-offset-by-sidebar\n      [@open]=\"{value: offset.sidebarOpen && offset.sidebarStretch ? 'visible': 'hidden', params: {marginLeft: offset.sidebarWidth}}\">\n    <ng-content></ng-content>\n  </div>\n  ",
            animations: [transition_1.sidebarAnimation]
        }),
        __metadata("design:paramtypes", [layout_1.LayoutService])
    ], FooterComponent);
    return FooterComponent;
}());
exports.FooterComponent = FooterComponent;
var FooterModule = /** @class */ (function () {
    function FooterModule() {
    }
    FooterModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, layout_1.LayoutModule],
            declarations: [FooterComponent],
            exports: [FooterComponent]
        })
    ], FooterModule);
    return FooterModule;
}());
exports.FooterModule = FooterModule;
