"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var get = require("lodash/get");
var set = require("lodash/set");
var tristatecheckbox_1 = require("primeng/tristatecheckbox");
var checkbox_1 = require("primeng/checkbox");
var calendar_1 = require("primeng/calendar");
var selectbutton_1 = require("primeng/selectbutton");
var dropdown_1 = require("primeng/dropdown");
var multiselect_1 = require("primeng/multiselect");
var rating_1 = require("primeng/rating");
var overlaypanel_1 = require("primeng/overlaypanel");
var datatable_1 = require("primeng/datatable");
var button_1 = require("./button");
var shared_1 = require("./shared");
var numeric_1 = require("./numeric");
var dropdown_datagrid_1 = require("./dropdown-datagrid");
var file_input_1 = require("./file-input");
var signature_1 = require("./signature");
var form_field_1 = require("./form-field");
var string_form_field_1 = require("./string-form-field");
var text_form_field_1 = require("./text-form-field");
var password_form_field_1 = require("./password-form-field");
var selectbar_form_field_1 = require("./selectbar-form-field");
var number_form_field_1 = require("./number-form-field");
var integer_form_field_1 = require("./integer-form-field");
var boolean_form_field_1 = require("./boolean-form-field");
var date_form_field_1 = require("./date-form-field");
var file_form_field_1 = require("./file-form-field");
var lookup_form_field_1 = require("./lookup-form-field");
var lookup_popup_form_field_1 = require("./lookup-popup-form-field");
var rating_form_field_1 = require("./rating-form-field");
function compare(name) {
    return function (control) {
        var other = control.root.get(name);
        return other && control.value != other.value
            ? {
                compare: { value: control.value }
            }
            : null;
    };
}
var FormFieldDirective = /** @class */ (function () {
    function FormFieldDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    Object.defineProperty(FormFieldDirective.prototype, "elementRef", {
        set: function (elementRef) {
            this.viewContainerRef.element.nativeElement.appendChild(elementRef.nativeElement);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input('rz-form-field'),
        __metadata("design:type", core_1.ElementRef),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], FormFieldDirective.prototype, "elementRef", null);
    FormFieldDirective = __decorate([
        core_1.Directive({
            selector: '[rz-form-field]'
        }),
        __metadata("design:paramtypes", [core_1.ViewContainerRef])
    ], FormFieldDirective);
    return FormFieldDirective;
}());
exports.FormFieldDirective = FormFieldDirective;
var FormComponent = /** @class */ (function () {
    function FormComponent(formBuilder) {
        this.formBuilder = formBuilder;
        this.columns = 1;
        this.repeat = 'horizontal';
        this.buttonPosition = 'bottom';
        this.visible = true;
        this.allowDelete = false;
        this.updateDataOnChange = false;
        this.submitChangesOnly = false;
        this.submitText = 'Save';
        this.deleteText = 'Delete';
        this.cancelText = 'Cancel';
        this.style = {};
        this.submit = new core_1.EventEmitter();
        this.delete = new core_1.EventEmitter();
        this.cancel = new core_1.EventEmitter();
        this.change = new core_1.EventEmitter();
        this.loadData = new core_1.EventEmitter();
        this.form = new forms_1.FormGroup({});
        this.valueChangesSubscriptions = [];
    }
    Object.defineProperty(FormComponent.prototype, "data", {
        set: function (data) {
            this.value = data;
            this.form = new forms_1.FormGroup({});
            this.createForm();
        },
        enumerable: true,
        configurable: true
    });
    FormComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.createForm();
        this.subscription = this.fields.changes.subscribe(function () { return _this.createForm(); });
    };
    FormComponent.prototype.createForm = function () {
        var _this = this;
        if (!this.fields) {
            return;
        }
        this.unsubscribe();
        var form = this.fields.reduce(function (form, field) {
            var value = _this.form.contains(field.property)
                ? _this.form.controls[field.property].value
                : get(_this.value, field.property, null);
            if (value == null && field.defaultValue != null) {
                value = field.defaultValue;
                if (typeof value == 'string' &&
                    (field instanceof integer_form_field_1.IntegerFormFieldComponent ||
                        field instanceof number_form_field_1.NumberFormFieldComponent ||
                        field instanceof boolean_form_field_1.BooleanFormFieldComponent)) {
                    try {
                        value = JSON.parse(value);
                    }
                    catch (err) { }
                }
            }
            if (value != null && field instanceof date_form_field_1.DateFormFieldComponent) {
                value = field.parse(value);
            }
            var validators = [];
            if (field.visible) {
                if (field.required) {
                    validators.push(forms_1.Validators.required);
                }
                if (field.compare) {
                    validators.push(compare(field.compare));
                }
                if (field instanceof number_form_field_1.NumberFormFieldComponent ||
                    field instanceof integer_form_field_1.IntegerFormFieldComponent) {
                    if (field.min != null) {
                        validators.push(forms_1.Validators.min(field.min));
                    }
                    if (field.max != null) {
                        validators.push(forms_1.Validators.max(field.max));
                    }
                }
            }
            form[field.property] = new forms_1.FormControl({ value: value, disabled: field.disabled }, validators);
            var control = form[field.property];
            field.control = control;
            field.onVisibilityChange = function () {
                _this.createForm();
            };
            if (field instanceof lookup_popup_form_field_1.LookupPopupFormFieldComponent) {
                field.onLoadData = function (event) {
                    _this.loadData.next(__assign({}, event, { property: field.property }));
                };
            }
            _this.valueChangesSubscriptions.push(control.valueChanges.subscribe(function (value) {
                _this.updateValue(control, field.property, value);
            }));
            return form;
        }, {});
        this.form = this.formBuilder.group(form);
        var fields = this.fields.toArray().filter(function (field) { return field.visible; });
        var rowCount = Math.ceil(fields.length / this.columns);
        var rows = [];
        for (var rowIndex = 0; rowIndex < rowCount; rowIndex++) {
            rows[rowIndex] = [];
            for (var colIndex = 0; colIndex < this.columns; colIndex++) {
                var fieldIndex = this.repeat == 'horizontal'
                    ? rowIndex * this.columns + colIndex
                    : colIndex * rowCount + rowIndex;
                var field = fields[fieldIndex];
                if (!field) {
                    continue;
                }
                rows[rowIndex][colIndex] = {
                    title: field.title,
                    visible: field.visible,
                    property: field.property,
                    elementRef: field.elementRef
                };
            }
        }
        this.cols = Math.floor(12 / this.columns);
        this.rows = rows;
    };
    FormComponent.prototype.updateValue = function (control, property, value) {
        if (control.valid) {
            this.change.next({
                property: property,
                value: value
            });
            if (this.updateDataOnChange && this.value) {
                set(this.value, property, value);
            }
        }
    };
    FormComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
        this.unsubscribe();
    };
    FormComponent.prototype.unsubscribe = function () {
        for (var _i = 0, _a = this.valueChangesSubscriptions; _i < _a.length; _i++) {
            var subscription = _a[_i];
            subscription.unsubscribe();
        }
        this.valueChangesSubscriptions = [];
    };
    FormComponent.prototype.changes = function () {
        var _this = this;
        var fields = this.fields.toArray();
        return Object.keys(this.form.controls)
            .filter(function (k, i) { return !(!_this.form.controls[k].dirty && !_this.form.controls[k].value && !fields[i].required); })
            .reduce(function (value, key, index) {
            var control = _this.form.controls[key];
            var field = fields.find(function (f) { return f.property == key; });
            if (control.dirty || _this.submitChangesOnly == false) {
                if (field instanceof date_form_field_1.DateFormFieldComponent && control.value) {
                    if (field.utc) {
                        var date = new Date(Date.UTC(control.value.getFullYear(), control.value.getMonth(), control.value.getDate(), control.value.getHours(), control.value.getMinutes(), control.value.getSeconds(), control.value.getMilliseconds()));
                        set(value, key, date.toISOString());
                    }
                    else {
                        set(value, key, control.value.toISOString());
                    }
                }
                else {
                    set(value, key, control.value);
                }
            }
            return value;
        }, {});
    };
    FormComponent.prototype.onSubmit = function (event) {
        event.preventDefault();
        event.stopPropagation();
        this.submitted = true;
        this.fields.forEach(function (field) {
            field.submitted = true;
        });
        var value = this.changes();
        if (this.form.valid) {
            if (this.submitChangesOnly) {
                this.submit.next(value);
            }
            else {
                if (this.value) {
                    Object.assign(this.value, value);
                }
                this.submit.next(this.value ? this.value : value);
            }
        }
    };
    FormComponent.prototype.onChange = function (event) {
        event.stopPropagation();
    };
    FormComponent.prototype.onCancel = function () {
        this.cancel.next();
    };
    FormComponent.prototype.onDelete = function () {
        this.delete.next(this.value);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], FormComponent.prototype, "data", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], FormComponent.prototype, "columns", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "repeat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "buttonPosition", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "titleBackground", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], FormComponent.prototype, "titleColor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "allowDelete", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "updateDataOnChange", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "submitChangesOnly", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "submitText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "deleteText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "cancelText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "submit", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "delete", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "cancel", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "change", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], FormComponent.prototype, "loadData", void 0);
    __decorate([
        core_1.ContentChildren(form_field_1.FormFieldComponent),
        __metadata("design:type", core_1.QueryList)
    ], FormComponent.prototype, "fields", void 0);
    FormComponent = __decorate([
        core_1.Component({
            selector: 'rz-form',
            template: "\n    <form\n      [ngStyle]=\"style\"\n      [formGroup]=\"form\"\n      (submit)=\"onSubmit($event)\"\n      (change)=\"onChange($event)\"\n      class=\"ui-form\"\n    >\n      <div\n        *ngIf=\"buttonPosition == 'top' || buttonPosition == 'topAndBottom'\"\n        class=\"form-group row\"\n      >\n        <div\n          class=\"col\"\n          [ngClass]=\"{\n            'offset-sm-3': columns < 2,\n            'd-flex justify-content-center align-items-center': columns > 1\n          }\"\n        >\n          <rz-button\n            buttonType=\"submit\"\n            icon=\"save\"\n            buttonStyle=\"primary\"\n            [text]=\"submitText\"\n          ></rz-button>\n          <rz-button\n            buttonStyle=\"danger\"\n            *ngIf=\"allowDelete\"\n            (click)=\"onDelete()\"\n            [text]=\"deleteText\"\n          ></rz-button>\n          <rz-button\n            buttonStyle=\"light\"\n            (click)=\"onCancel()\"\n            [text]=\"cancelText\"\n          ></rz-button>\n        </div>\n      </div>\n      <div\n        class=\"form-row ui-fluid\"\n        [ngClass]=\"{'form-group': columns < 2}\"\n        *ngFor=\"let row of rows\"\n      >\n        <ng-container *ngFor=\"let cell of row\">\n          <div\n            *ngIf=\"columns > 1\"\n            class=\"form-group col-md-{{cols}}\"\n            [rz-form-field]=\"cell.elementRef\"\n          >\n            <label class=\"form-label\" [attr.for]=\"cell.property\">{{\n              cell.title\n            }}</label>\n          </div>\n          <label\n            *ngIf=\"columns < 2\"\n            class=\"col-md-3 col-form-label\"\n            [attr.for]=\"cell.property\"\n            >{{ cell.title }}</label\n          >\n          <div\n            *ngIf=\"columns < 2\"\n            class=\"col\"\n            [rz-form-field]=\"cell.elementRef\"\n          ></div>\n        </ng-container>\n      </div>\n      <div\n        *ngIf=\"buttonPosition == 'bottom' || buttonPosition == 'topAndBottom'\"\n        class=\"form-group row\"\n      >\n        <div\n          class=\"col\"\n          [ngClass]=\"{\n            'offset-sm-3': columns < 2,\n            'd-flex justify-content-center align-items-center': columns > 1\n          }\"\n        >\n          <rz-button\n            buttonType=\"submit\"\n            icon=\"save\"\n            buttonStyle=\"primary\"\n            [text]=\"submitText\"\n          ></rz-button>\n          <rz-button\n            buttonStyle=\"danger\"\n            *ngIf=\"allowDelete\"\n            (click)=\"onDelete()\"\n            [text]=\"deleteText\"\n          ></rz-button>\n          <rz-button\n            buttonStyle=\"light\"\n            (click)=\"onCancel()\"\n            [text]=\"cancelText\"\n          ></rz-button>\n        </div>\n      </div>\n    </form>\n  "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder])
    ], FormComponent);
    return FormComponent;
}());
exports.FormComponent = FormComponent;
var FormModule = /** @class */ (function () {
    function FormModule() {
    }
    FormModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
                forms_1.ReactiveFormsModule,
                shared_1.SharedModule,
                button_1.ButtonModule,
                numeric_1.NumericModule,
                file_input_1.FileInputModule,
                signature_1.SignatureModule,
                dropdown_datagrid_1.DropDownDataGridModule,
                tristatecheckbox_1.TriStateCheckboxModule,
                calendar_1.CalendarModule,
                selectbutton_1.SelectButtonModule,
                checkbox_1.CheckboxModule,
                dropdown_1.DropdownModule,
                multiselect_1.MultiSelectModule,
                rating_1.RatingModule,
                overlaypanel_1.OverlayPanelModule,
                datatable_1.DataTableModule,
                forms_1.FormsModule
            ],
            declarations: [
                FormFieldDirective,
                FormComponent,
                integer_form_field_1.IntegerFormFieldComponent,
                number_form_field_1.NumberFormFieldComponent,
                boolean_form_field_1.BooleanFormFieldComponent,
                date_form_field_1.DateFormFieldComponent,
                string_form_field_1.StringFormFieldComponent,
                text_form_field_1.TextFormFieldComponent,
                password_form_field_1.PasswordFormFieldComponent,
                selectbar_form_field_1.SelectBarFormFieldComponent,
                selectbar_form_field_1.SelectBarFormFieldOptionComponent,
                file_form_field_1.FileFormFieldComponent,
                lookup_form_field_1.LookupFormFieldComponent,
                lookup_form_field_1.LookupFormFieldTemplate,
                lookup_popup_form_field_1.LookupPopupFormFieldComponent,
                lookup_popup_form_field_1.LookupPopupFormFieldColumn,
                lookup_popup_form_field_1.LookupPopupFormFieldColumnTemplate,
                rating_form_field_1.RatingFormFieldComponent
            ],
            exports: [
                FormComponent,
                FormFieldDirective,
                integer_form_field_1.IntegerFormFieldComponent,
                number_form_field_1.NumberFormFieldComponent,
                boolean_form_field_1.BooleanFormFieldComponent,
                date_form_field_1.DateFormFieldComponent,
                string_form_field_1.StringFormFieldComponent,
                text_form_field_1.TextFormFieldComponent,
                password_form_field_1.PasswordFormFieldComponent,
                selectbar_form_field_1.SelectBarFormFieldComponent,
                selectbar_form_field_1.SelectBarFormFieldOptionComponent,
                file_form_field_1.FileFormFieldComponent,
                lookup_form_field_1.LookupFormFieldComponent,
                lookup_form_field_1.LookupFormFieldTemplate,
                lookup_popup_form_field_1.LookupPopupFormFieldComponent,
                lookup_popup_form_field_1.LookupPopupFormFieldColumn,
                lookup_popup_form_field_1.LookupPopupFormFieldColumnTemplate,
                rating_form_field_1.RatingFormFieldComponent
            ]
        })
    ], FormModule);
    return FormModule;
}());
exports.FormModule = FormModule;
