"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var ngx_charts_1 = require("@swimlane/ngx-charts");
var shared_1 = require("./shared");
var GaugeComponent = /** @class */ (function () {
    function GaugeComponent() {
        this.style = {};
        this.value = 0;
        this.min = 0;
        this.max = 100;
        this.angleSpan = 240;
        this.startAngle = -120;
        this.showAxis = false;
        this.color = '#479cc8';
        this.smallSegments = 2;
        this.largeSegments = 5;
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GaugeComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GaugeComponent.prototype, "value", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GaugeComponent.prototype, "min", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GaugeComponent.prototype, "max", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GaugeComponent.prototype, "unit", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GaugeComponent.prototype, "angleSpan", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GaugeComponent.prototype, "startAngle", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], GaugeComponent.prototype, "showAxis", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GaugeComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GaugeComponent.prototype, "color", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GaugeComponent.prototype, "smallSegments", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GaugeComponent.prototype, "largeSegments", void 0);
    GaugeComponent = __decorate([
        core_1.Component({
            selector: 'rz-gauge',
            template: "\n    <div class=\"ui-gauge\" [ngStyle]=\"style\">\n      <ngx-charts-gauge\n        [results]=\"value != null ? [{name:'', value: value}] : []\"\n        [min]=\"min\"\n        [units]=\"unit\"\n        [scheme]=\"{domain:[color]}\"\n        [textValue]=\"text\"\n        [angleSpan]=\"angleSpan\"\n        [startAngle]=\"startAngle\"\n        [showAxis]=\"showAxis\"\n        [animations]=\"false\"\n        [bigSegments]=\"largeSegments\"\n        [smallSegments]=\"smallSegments\"\n        [margin]=\"showAxis ? null : [2,2,2,2]\"\n        [max]=\"max\">\n      </ngx-charts-gauge>\n    </div>\n  "
        })
    ], GaugeComponent);
    return GaugeComponent;
}());
exports.GaugeComponent = GaugeComponent;
var GaugeModule = /** @class */ (function () {
    function GaugeModule() {
    }
    GaugeModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, ngx_charts_1.NgxChartsModule, shared_1.SharedModule],
            declarations: [GaugeComponent],
            exports: [GaugeComponent]
        })
    ], GaugeModule);
    return GaugeModule;
}());
exports.GaugeModule = GaugeModule;
