"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var listbox_1 = require("primeng/listbox");
var overlaypanel_1 = require("primeng/overlaypanel");
var datatable_1 = require("primeng/datatable");
var calendar_1 = require("primeng/calendar");
var tristatecheckbox_1 = require("primeng/tristatecheckbox");
var api_1 = require("primeng/components/common/api");
var confirmdialog_1 = require("primeng/components/confirmdialog/confirmdialog");
var get = require("lodash/get");
var shared_1 = require("./shared");
var button_1 = require("./button");
var numeric_1 = require("./numeric");
var validator_1 = require("./validator");
var template_form_1 = require("./template-form");
var GridTemplateDirective = /** @class */ (function () {
    function GridTemplateDirective(template) {
        this.template = template;
    }
    GridTemplateDirective = __decorate([
        core_1.Directive({
            selector: '[gridTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], GridTemplateDirective);
    return GridTemplateDirective;
}());
exports.GridTemplateDirective = GridTemplateDirective;
var GridColumnFooterTemplate = /** @class */ (function () {
    function GridColumnFooterTemplate(templateRef) {
        this.templateRef = templateRef;
    }
    GridColumnFooterTemplate = __decorate([
        core_1.Directive({
            selector: '[gridColumnFooterTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], GridColumnFooterTemplate);
    return GridColumnFooterTemplate;
}());
exports.GridColumnFooterTemplate = GridColumnFooterTemplate;
var GridColumnTemplate = /** @class */ (function () {
    function GridColumnTemplate(templateRef) {
        this.templateRef = templateRef;
    }
    GridColumnTemplate = __decorate([
        core_1.Directive({
            selector: '[gridColumnTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], GridColumnTemplate);
    return GridColumnTemplate;
}());
exports.GridColumnTemplate = GridColumnTemplate;
var GridColumnEditTemplate = /** @class */ (function () {
    function GridColumnEditTemplate(templateRef) {
        this.templateRef = templateRef;
    }
    GridColumnEditTemplate = __decorate([
        core_1.Directive({
            selector: '[gridColumnEditTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], GridColumnEditTemplate);
    return GridColumnEditTemplate;
}());
exports.GridColumnEditTemplate = GridColumnEditTemplate;
function getUnit(value) {
    var unit = value.match(/\D+$/);
    return unit ? unit[0] : 'px';
}
exports.getUnit = getUnit;
function getNumeric(value) {
    var match = value.match(/^\d+/);
    var numeric = match ? match[0] : '0';
    return parseFloat(numeric);
}
exports.getNumeric = getNumeric;
var GridColumn = /** @class */ (function () {
    function GridColumn(grid) {
        this.grid = grid;
        this.type = 'string';
        this.sortable = true;
        this.filterable = true;
        this.textAlign = 'left';
    }
    Object.defineProperty(GridColumn.prototype, "style", {
        get: function () {
            var style = {};
            var width = this.width;
            if (width == null &&
                this.grid &&
                !this.grid.allowColumnResize &&
                this.grid.columnWidth != 'auto') {
                width = this.grid.columnWidth;
            }
            if (width != null) {
                var value = width.toString();
                var unit = getUnit(value);
                var numeric = getNumeric(value);
                style.width = "" + numeric + unit;
            }
            if (this.textAlign != 'left') {
                style.textAlign = this.textAlign;
            }
            return style;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridColumn.prototype, "formatString", {
        get: function () {
            return this._formatString;
        },
        set: function (format) {
            this._formatString = format;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridColumn.prototype, "filterOperator", {
        get: function () {
            if (!this._filterOperator) {
                this._filterOperator =
                    this.filterProperty || (this.type == 'string' && !this.format)
                        ? 'contains'
                        : 'eq';
            }
            return this._filterOperator;
        },
        set: function (operator) {
            this._filterOperator = operator;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridColumn.prototype, "filterOperators", {
        get: function () {
            if (!this._filterOperators) {
                this._filterOperators = (this.filterProperty ||
                    (this.type == 'string' && !this.format)
                    ? [
                        {
                            label: 'Starts with',
                            value: 'startswith'
                        },
                        {
                            label: 'Contains',
                            value: 'contains'
                        },
                        {
                            label: 'Ends with',
                            value: 'endswith'
                        }
                    ]
                    : []).concat([
                    {
                        label: 'Equals',
                        value: 'eq'
                    },
                    {
                        label: 'Not equals',
                        value: 'ne'
                    },
                    {
                        label: 'Less than',
                        value: 'lt'
                    },
                    {
                        label: 'Less than or equals',
                        value: 'le'
                    },
                    {
                        label: 'Greater than',
                        value: 'gt'
                    },
                    {
                        label: 'Greater than or equals',
                        value: 'ge'
                    }
                ]);
            }
            return this._filterOperators;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "tooltip", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "type", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "format", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "property", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "sortProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "filterProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "filterValue", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "sortable", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "filterable", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "width", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridColumn.prototype, "textAlign", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], GridColumn.prototype, "formatString", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], GridColumn.prototype, "filterOperator", null);
    __decorate([
        core_1.ContentChild(GridColumnTemplate),
        __metadata("design:type", core_1.TemplateRef)
    ], GridColumn.prototype, "template", void 0);
    __decorate([
        core_1.ContentChild(GridColumnFooterTemplate),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "footerTemplate", void 0);
    __decorate([
        core_1.ContentChild(GridColumnEditTemplate),
        __metadata("design:type", Object)
    ], GridColumn.prototype, "editTemplate", void 0);
    GridColumn = __decorate([
        core_1.Component({
            selector: 'rz-grid-column',
            template: ''
        }),
        __param(0, core_1.Host()), __param(0, core_1.Inject(core_1.forwardRef(function () { return GridComponent; }))),
        __metadata("design:paramtypes", [GridComponent])
    ], GridColumn);
    return GridColumn;
}());
exports.GridColumn = GridColumn;
var GridComponent = /** @class */ (function () {
    function GridComponent(confirmationService, validatorService) {
        this.confirmationService = confirmationService;
        this.validatorService = validatorService;
        this.style = {};
        this.allowDelete = false;
        this.confirmDelete = false;
        this.confirmDeleteTitle = 'Confirmation';
        this.confirmDeleteText = 'Are you sure you want to delete this record?';
        this.confirmDeleteOkText = 'Ok';
        this.confirmDeleteCancelText = 'Cancel';
        this.allowAdd = false;
        this.allowSorting = false;
        this.allowMultiSorting = false;
        this.allowPaging = false;
        this.alwaysShowPager = false;
        this.allowFiltering = false;
        this.allowScrolling = true;
        this.allowColumnResize = false;
        this.allowColumnReorder = false;
        this.applyFilterText = 'Apply';
        this.clearFilterText = 'Clear';
        this.filterDateFormat = 'MM/dd/yy';
        this.columnResizeMode = 'fit';
        this.skip = 0;
        this.dataItemsInEditMode = new WeakMap();
        this.columnWidth = 'auto';
        this.pageSizeOptions = null;
        this.visible = true;
        this.emptyText = 'No records to display.';
        this.addText = 'Add';
        this.expandableGroups = false;
        this.rowSelect = new core_1.EventEmitter();
        this.rowDoubleClick = new core_1.EventEmitter();
        this.rowExpand = new core_1.EventEmitter();
        this.rowCollapse = new core_1.EventEmitter();
        this.delete = new core_1.EventEmitter();
        this.update = new core_1.EventEmitter();
        this.create = new core_1.EventEmitter();
        this.add = new core_1.EventEmitter();
        this.loadData = new core_1.EventEmitter();
        this.valueChange = new core_1.EventEmitter();
        this.loading = false;
        this.top = 10;
        this.multiSortMeta = [];
        this.state = {
            skip: 0,
            top: 0,
            filter: [],
            sort: []
        };
        this.orderBy = '';
        this.filter = '';
        this.timeout = null;
        var now = new Date();
        this.today = new Date(now.getFullYear(), now.getMonth(), now.getDate());
    }
    Object.defineProperty(GridComponent.prototype, "pageSize", {
        get: function () {
            return this.top;
        },
        set: function (value) {
            this.top = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridComponent.prototype, "styleClass", {
        get: function () {
            var classNames = [];
            if (this.allowPaging) {
                classNames.push('ui-has-paginator');
            }
            if (this.style && this.style.hasOwnProperty('height')) {
                classNames.push('ui-has-height');
            }
            if (this.expandableTemplate) {
                classNames.push('ui-has-template');
            }
            if (this.rowSelect.observers.length > 0) {
                classNames.push('ui-selectable');
            }
            if (classNames.length) {
                return classNames.join(' ');
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    GridComponent.prototype.insertRow = function (data) {
        this.dataItemsInEditMode.set(data, data);
        this.validatorService.setContext(data);
        this.data = [data].concat(this.data);
    };
    GridComponent.prototype.editRow = function (data) {
        if (!this.dataItemsInEditMode.has(data)) {
            var original = Object.assign({}, data);
            this.dataItemsInEditMode.set(data, original);
            this.validatorService.setContext(data);
        }
    };
    GridComponent.prototype.cancelEditRow = function (data) {
        var original = this.dataItemsInEditMode.get(data);
        this.dataItemsInEditMode.delete(data);
        this.validatorService.deleteContext(data);
        if (original === data) {
            this.data = this.data.filter(function (item) { return item !== data; });
        }
        else {
            Object.assign(data, original);
        }
    };
    GridComponent.prototype.updateRow = function (data) {
        var valid = this.validatorService.valid(data);
        if (valid) {
            var original = this.dataItemsInEditMode.get(data);
            this.dataItemsInEditMode.delete(data);
            this.validatorService.deleteContext(data);
            if (original === data) {
                this.create.next(data);
            }
            else {
                this.update.next(data);
            }
        }
    };
    GridComponent.prototype.inEditMode = function (data) {
        return this.dataItemsInEditMode.has(data);
    };
    Object.defineProperty(GridComponent.prototype, "value", {
        get: function () {
            return this.selection;
        },
        set: function (value) {
            if (this.selection !== value) {
                this.selection = value;
                this.valueChange.emit(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    GridComponent.prototype.groupHeader = function (data) {
        return get(data, this.groupProperty);
    };
    GridComponent.prototype.ngAfterContentInit = function () {
        if (this.dataTable) {
            this.dataTable.fixColumnWidths = function () { };
        }
    };
    GridComponent.prototype.onSelect = function (value) {
        if (value) {
            this.value = value;
            this.rowSelect.next(value);
        }
    };
    GridComponent.prototype.onRowExpand = function (value) {
        this.rowExpand.next(value);
    };
    GridComponent.prototype.onRowDoubleClick = function (value) {
        this.rowDoubleClick.next(value);
    };
    GridComponent.prototype.onRowCollapse = function (value) {
        this.rowCollapse.next(value);
    };
    GridComponent.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('data')) {
            this.loading = false;
        }
    };
    GridComponent.prototype.onDelete = function (data) {
        var _this = this;
        if (this.confirmDelete) {
            var message = !!window.MSInputMethodContext && !!document.documentMode
                ? this.confirmDeleteText
                : new Function('data', 'return `' + this.confirmDeleteText + '`;').call(this, data);
            this.confirmationService.confirm({
                message: message,
                header: this.confirmDeleteTitle,
                acceptLabel: this.confirmDeleteOkText,
                rejectLabel: this.confirmDeleteCancelText,
                accept: function () {
                    _this.delete.next(data);
                }
            });
        }
        else {
            this.delete.next(data);
        }
    };
    GridComponent.prototype.onAdd = function (value) {
        this.add.next(value);
    };
    GridComponent.prototype.onPage = function (event) {
        if (this.skip != event.first || this.top != event.rows) {
            this.skip = event.first;
            this.top = event.rows;
            this.callLoadData();
        }
    };
    GridComponent.prototype.onSort = function (event) {
        if (this.allowSorting && event.field) {
            var field = event.multisortmeta.find(function (i) { return i && i.field == event.field; });
            if (!this.allowMultiSorting) {
                event.multisortmeta.splice(event.multisortmeta.indexOf(field), 1);
                field = null;
            }
            if (field) {
                if (field.order == -1 && event.order == 1) {
                    event.multisortmeta.splice(event.multisortmeta.indexOf(field), 1);
                }
                else {
                    field.order = event.order;
                }
            }
            else {
                event.multisortmeta.push({ field: event.field, order: event.order });
            }
        }
        this.orderBy = this.allowSorting
            ? orderByToString(event.multisortmeta)
            : '';
        this.skip = 0;
        this.callLoadData();
    };
    GridComponent.prototype.onFilter = function (event) {
        this.rawFilters = event.filters;
        var filter = this.allowFiltering
            ? filtersToString(event.filters, this.columns ? this.columns.toArray() : [])
            : '';
        this.filter = filter;
        this.skip = 0;
        this.callLoadData();
    };
    GridComponent.prototype.onDateFilter = function (dt, value, column, op) {
        op.hide();
        column.filterValue = value;
        dt.filter(value == '' ? null : value, column.filterProperty || column.property, this.filterOperator(dt, column.filterOperator));
    };
    GridComponent.prototype.onBooleanFilter = function (dt, value, column) {
        column.filterValue = value;
        dt.filter(value, column.filterProperty || column.property, this.filterOperator(dt, column.filterOperator));
    };
    GridComponent.prototype.onStringFilter = function (dt, value, column) {
        var _this = this;
        column.filterValue = value;
        clearTimeout(this.timeout);
        this.timeout = setTimeout(function () {
            dt.filter(value, column.filterProperty || column.property, _this.filterOperator(dt, column.filterOperator));
        }, 500);
    };
    GridComponent.prototype.onNumberFilter = function (dt, value, column) {
        column.filterValue = value;
        dt.filter(value, column.filterProperty || column.property, this.filterOperator(dt, column.filterOperator));
    };
    GridComponent.prototype.onFilterMenu = function (dt, column, op) {
        op.hide();
        dt.filter(column.filterValue, column.filterProperty || column.property, this.filterOperator(dt, column.filterOperator));
    };
    GridComponent.prototype.load = function () {
        this.callLoadData();
    };
    GridComponent.prototype.callLoadData = function () {
        var _this = this;
        this.loading = true;
        var columns = this.columns ? this.columns.toArray() : [];
        this.state.skip = this.allowPaging ? this.skip : null;
        this.state.top = this.allowPaging ? this.top : null;
        this.state.sort = this.allowSorting
            ? this.orderBy.split(',').map(function (o) {
                return {
                    property: o.indexOf(' ') ? o.split(' ').shift() : o,
                    sortOrder: o.indexOf(' desc') != -1 ? 'descending' : 'ascending'
                };
            })
            : [];
        this.state.filter =
            this.allowFiltering && this.rawFilters
                ? Object.keys(this.rawFilters)
                    .map(function (key) {
                    var column = columns.find(function (c) { return c.filterProperty == key || c.property == key; });
                    return column && column.filterOperator
                        ? {
                            property: key,
                            value: _this.rawFilters[key].value,
                            operator: _this.filterOperatorToState(column.filterOperator)
                        }
                        : null;
                })
                    .filter(function (i) { return i != null; })
                : [];
        this.loadData.next({
            skip: this.allowPaging ? this.skip : null,
            top: this.allowPaging ? this.top : null,
            orderby: this.orderBy,
            filter: this.filter,
            state: this.state
        });
    };
    GridComponent.prototype.filterOperator = function (dt, filterOperator) {
        if (dt.lazy) {
            return filterOperator;
        }
        switch (filterOperator) {
            case 'eq':
                return 'equals';
            case 'ne':
                return 'notEquals';
            case 'ge':
                return 'gte';
            case 'le':
                return 'lte';
            case 'startswith':
                return 'startsWith';
            case 'endswith':
                return 'endsWith';
            default:
                return filterOperator;
        }
    };
    GridComponent.prototype.filterOperatorToState = function (filterOperator) {
        switch (filterOperator) {
            case 'eq':
                return 'equal';
            case 'ne':
                return 'notEqual';
            case 'ge':
                return 'greaterThanOrEqual';
            case 'gt':
                return 'greaterThan';
            case 'le':
                return 'lessThanOrEqual';
            case 'lt':
                return 'lessThan';
            case 'startswith':
                return 'startsWith';
            case 'endswith':
                return 'endsWith';
            default:
                return filterOperator;
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], GridComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowDelete", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "confirmDelete", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "confirmDeleteTitle", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "confirmDeleteText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "confirmDeleteOkText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "confirmDeleteCancelText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowAdd", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowSorting", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowMultiSorting", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowPaging", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "alwaysShowPager", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowFiltering", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowScrolling", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowColumnResize", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "allowColumnReorder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "applyFilterText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "clearFilterText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "filterDateFormat", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "columnResizeMode", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "skip", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], GridComponent.prototype, "pageSize", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "columnWidth", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "pageSizeOptions", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], GridComponent.prototype, "count", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "titleBackground", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "titleColor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "emptyText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "addText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], GridComponent.prototype, "isLoading", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], GridComponent.prototype, "groupProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "expandableGroups", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "rowSelect", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "rowDoubleClick", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "rowExpand", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "rowCollapse", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "delete", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "update", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "create", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "add", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "loadData", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "valueChange", void 0);
    __decorate([
        core_1.ContentChild(GridTemplateDirective),
        __metadata("design:type", GridTemplateDirective)
    ], GridComponent.prototype, "expandableTemplate", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], GridComponent.prototype, "value", null);
    __decorate([
        core_1.ViewChild(datatable_1.DataTable),
        __metadata("design:type", Object)
    ], GridComponent.prototype, "dataTable", void 0);
    __decorate([
        core_1.ContentChildren(GridColumn),
        __metadata("design:type", core_1.QueryList)
    ], GridComponent.prototype, "columns", void 0);
    GridComponent = __decorate([
        core_1.Component({
            selector: 'rz-grid',
            providers: [
                api_1.ConfirmationService,
                template_form_1.hideTemplateFromTemplateForm(),
                validator_1.ValidatorService
            ],
            template: "\n    <p-dataTable\n      [selectionMode]=\"rowSelect.observers.length > 0 ? 'single' : null\"\n      [styleClass]=\"styleClass\"\n      [style]=\"style\"\n      [scrollable]=\"allowScrolling\"\n      [scrollWidth]=\"style?.width\"\n      [responsive]=\"true\"\n      [alwaysShowPaginator]=\"alwaysShowPager\"\n      [lazy]=\"loadData.observers.length > 0\"\n      [loading]=\"isLoading || (loadData.observers.length > 0 && loading)\"\n      [value]=\"data\"\n      [totalRecords]=\"count\"\n      [emptyMessage]=\"data ? emptyText : null\"\n      (onPage)=\"onPage($event)\"\n      (onSort)=\"onSort($event)\"\n      (onRowExpand)=\"onRowExpand($event.data)\"\n      (onRowCollapse)=\"onRowCollapse($event.data)\"\n      (onFilter)=\"onFilter($event)\"\n      [sortMode]=\"\n        allowSorting ? (allowMultiSorting ? 'multiple' : 'single') : null\n      \"\n      [multiSortMeta]=\"multiSortMeta\"\n      [(selection)]=\"value\"\n      [rowsPerPageOptions]=\"pageSizeOptions\"\n      (onRowSelect)=\"onSelect($event.data)\"\n      (onRowDblclick)=\"onRowDoubleClick($event.data)\"\n      [rows]=\"allowPaging ? pageSize : -1\"\n      [first]=\"allowPaging ? skip : 0\"\n      [groupField]=\"groupProperty\"\n      [rowGroupMode]=\"groupProperty ? 'subheader' : null\"\n      [paginator]=\"allowPaging\"\n      [expandableRows]=\"!!expandableTemplate\"\n      [expandableRowGroups]=\"expandableGroups\"\n      [reorderableColumns]=\"allowColumnReorder\"\n      [resizableColumns]=\"allowColumnResize\"\n      [columnResizeMode]=\"columnResizeMode\"\n      #dataTable\n    >\n      <p-column\n        expander=\"true\"\n        *ngIf=\"!!expandableTemplate\"\n        styleClass=\"col-icon\"\n      ></p-column>\n      <ng-template *ngIf=\"groupProperty\" pTemplate=\"rowgroupheader\" let-data>{{\n        groupHeader(data)\n      }}</ng-template>\n      <p-header *ngIf=\"allowAdd\">\n        <rz-button\n          icon=\"add_circle_outline\"\n          (click)=\"onAdd(data)\"\n          buttonStyle=\"primary\"\n          [text]=\"addText\"\n        ></rz-button>\n      </p-header>\n      <p-column\n        *ngFor=\"let column of columns; let index = index\"\n        [style]=\"column.style\"\n        [field]=\"column.property\"\n        [header]=\"column.title\"\n        [sortField]=\"column.sortProperty\"\n        [filterField]=\"column.filterProperty\"\n        [sortable]=\"\n          allowSorting && column.sortable\n            ? loadData.observers.length > 0\n              ? 'custom'\n              : true\n            : false\n        \"\n        [filter]=\"\n          column.format == 'date-time-offset' ||\n          column.format == 'time' ||\n          column.format == 'geometry' ||\n          column.format == 'geography' ||\n          column.format == 'base64'\n            ? false\n            : allowFiltering && column.filterable\n        \"\n      >\n        <ng-template *ngIf=\"column.tooltip\" pTemplate=\"header\">\n          <span [title]=\"column.tooltip\">{{ column.title }}</span>\n        </ng-template>\n\n        <ng-template pTemplate=\"body\" let-data=\"rowData\">\n          <ng-container *ngIf=\"!column.editTemplate || !inEditMode(data)\">\n            <ng-template\n              *ngIf=\"column.template\"\n              [ngTemplateOutlet]=\"column.template.templateRef\"\n              [ngTemplateOutletContext]=\"{$implicit: data}\"\n            >\n            </ng-template>\n            <span\n              class=\"ui-cell-data\"\n              *ngIf=\"!column.template && !column.formatString\"\n            >\n              {{ dataTable.resolveFieldData(data, column.property) }}\n            </span>\n            <span\n              class=\"ui-cell-data\"\n              *ngIf=\"!column.template && column.formatString\"\n            >\n              <ng-container *ngIf=\"column.format == 'date-time'\">\n                {{ data[column.property] | utcDate: column.formatString }}\n              </ng-container>\n              <ng-container\n                *ngIf=\"\n                  column.formatString == 'currency' && column.type == 'number'\n                \"\n              >\n                {{ data[column.property] | currency }}\n              </ng-container>\n              <ng-container\n                *ngIf=\"\n                  column.formatString == 'percent' && column.type == 'number'\n                \"\n              >\n                {{ data[column.property] | percent }}\n              </ng-container>\n              <ng-container\n                *ngIf=\"\n                  column.formatString == 'uppercase' &&\n                  column.type == 'string' &&\n                  !column.format\n                \"\n              >\n                {{ data[column.property] | uppercase }}\n              </ng-container>\n              <ng-container\n                *ngIf=\"\n                  column.formatString == 'titlecase' &&\n                  column.type == 'string' &&\n                  !column.format\n                \"\n              >\n                {{ data[column.property] | titlecase }}\n              </ng-container>\n            </span>\n          </ng-container>\n          <ng-container *ngIf=\"column.editTemplate && inEditMode(data)\">\n            <ng-template\n              [ngTemplateOutlet]=\"column.editTemplate.templateRef\"\n              [ngTemplateOutletContext]=\"{$implicit: data}\"\n            >\n            </ng-template>\n          </ng-container>\n        </ng-template>\n\n        <ng-template\n          *ngIf=\"column.footerTemplate\"\n          pTemplate=\"footer\"\n          let-data=\"rowData\"\n        >\n          <ng-template\n            [ngTemplateOutlet]=\"column.footerTemplate.templateRef\"\n            [ngTemplateOutletContext]=\"{$implicit: data}\"\n          >\n          </ng-template>\n        </ng-template>\n        <ng-template\n          *ngIf=\"\n            column.type == 'boolean' && allowFiltering && column.filterable\n          \"\n          pTemplate=\"filter\"\n        >\n          <div class=\"ui-cell-filter\">\n            <div class=\"ui-cell-filter-content\">\n              <p-triStateCheckbox\n                [ngModel]=\"column.filterValue\"\n                (onChange)=\"onBooleanFilter(dataTable, $event.value, column)\"\n              >\n              </p-triStateCheckbox>\n            </div>\n          </div>\n        </ng-template>\n        <ng-template\n          *ngIf=\"\n            column.filterable &&\n            (column.type == 'text' || column.type == 'string')\n          \"\n          pTemplate=\"filter\"\n        >\n          <div class=\"ui-cell-filter\">\n            <div class=\"ui-cell-filter-content\">\n              <label>\n                <i class=\"material-icons\">search</i>\n                <input\n                  [ngModel]=\"column.filterValue\"\n                  (input)=\"\n                    onStringFilter(dataTable, $event.target.value, column)\n                  \"\n                />\n              </label>\n            </div>\n          </div>\n        </ng-template>\n        <ng-template\n          *ngIf=\"\n            column.filterable &&\n            (column.type == 'integer' || column.type == 'number')\n          \"\n          pTemplate=\"filter\"\n        >\n          <div class=\"ui-cell-filter\">\n            <div class=\"ui-cell-filter-content\">\n              <label>\n                <i class=\"material-icons\">search</i>\n                <rz-numeric\n                  [ngModel]=\"column.filterValue\"\n                  (change)=\"onNumberFilter(dataTable, $event, column)\"\n                ></rz-numeric>\n              </label>\n            </div>\n          </div>\n        </ng-template>\n        <ng-template\n          *ngIf=\"\n            (column.format == 'date-time' || column.format == 'date') &&\n            allowFiltering &&\n            column.filterable\n          \"\n          pTemplate=\"filter\"\n          let-col\n        >\n          <div class=\"ui-cell-filter\">\n            <div class=\"ui-cell-filter-content\">\n              <i class=\"material-icons\" (click)=\"op.toggle($event)\"\n                >date_range</i\n              >\n              <span class=\"ui-current-filter\" *ngIf=\"column.filterValue\">{{\n                column.filterValue | date: filterDateFormat\n              }}</span>\n              <i\n                *ngIf=\"column.filterValue\"\n                class=\"material-icons ui-cell-filter-clear\"\n                (click)=\"onDateFilter(dataTable, null, column, op)\"\n                >close</i\n              >\n            </div>\n            <p-overlayPanel appendTo=\"body\" #op>\n              <div class=\"ui-date-filter\">\n                <p-listbox\n                  class=\"filter-listbox\"\n                  [options]=\"column.filterOperators\"\n                  [(ngModel)]=\"column.filterOperator\"\n                >\n                </p-listbox>\n                <p-calendar\n                  (click)=\"$event.stopPropagation()\"\n                  [dateFormat]=\"filterDateFormat\"\n                  #fc\n                  appendTo=\"body\"\n                  [defaultDate]=\"today\"\n                  [showTime]=\"column.format == 'date-time'\"\n                  [showIcon]=\"false\"\n                  [yearNavigator]=\"true\"\n                  yearRange=\"1950:2050\"\n                  [monthNavigator]=\"true\"\n                  [(ngModel)]=\"column.filterValue\"\n                  [inline]=\"true\"\n                >\n                </p-calendar>\n              </div>\n              <div class=\"ui-date-filter-buttons\">\n                <button\n                  class=\"ui-button ui-clear-filter\"\n                  (click)=\"onDateFilter(dataTable, null, column, op)\"\n                >\n                  {{ clearFilterText }}\n                </button>\n                <button\n                  class=\"ui-button ui-apply-filter\"\n                  (click)=\"\n                    onDateFilter(dataTable, column.filterValue, column, op)\n                  \"\n                >\n                  {{ applyFilterText }}\n                </button>\n              </div>\n            </p-overlayPanel>\n          </div>\n        </ng-template>\n      </p-column>\n      <p-column\n        *ngIf=\"allowDelete\"\n        [style]=\"{width: '70px', 'text-align': 'center'}\"\n      >\n        <ng-template let-data=\"rowData\" pTemplate=\"body\">\n          <rz-button\n            buttonStyle=\"danger\"\n            size=\"sm\"\n            icon=\"close\"\n            (click)=\"onDelete(data)\"\n          ></rz-button>\n        </ng-template>\n      </p-column>\n      <ng-template *ngIf=\"expandableTemplate\" pTemplate=\"rowexpansion\" let-data>\n        <div class=\"ui-expanded-row-template\">\n          <ng-template\n            [ngTemplateOutlet]=\"expandableTemplate.template\"\n            [ngTemplateOutletContext]=\"{$implicit: data}\"\n          >\n          </ng-template>\n        </div>\n      </ng-template>\n    </p-dataTable>\n    <p-confirmDialog\n      [style]=\"{width: '425px'}\"\n      appendTo=\"body\"\n    ></p-confirmDialog>\n  "
        }),
        __metadata("design:paramtypes", [api_1.ConfirmationService,
            validator_1.ValidatorService])
    ], GridComponent);
    return GridComponent;
}());
exports.GridComponent = GridComponent;
function orderByToString(multiSortMeta) {
    return multiSortMeta
        .map(function (i) { return "" + i.field.replace(/[.]/g, '/') + (i.order == -1 ? ' desc' : ''); })
        .join(',');
}
exports.orderByToString = orderByToString;
function filtersToString(filters, columns) {
    return Object.keys(filters)
        .map(function (key) {
        return filterToString(key.replace(/[.]/g, '/'), filters[key], columns.find(function (c) { return c.filterProperty == key || c.property == key; }));
    })
        .filter(function (i) { return i != null; })
        .join(' and ');
}
function filterToString(key, filter, column) {
    var value = filter.value === '' ? null : filter.value;
    if (column && column.type) {
        if (column.type == 'string') {
            var format = column.filterProperty ? null : column.format;
            if ((format == 'date-time' || format == 'date') &&
                (new Date(value) instanceof Date || value)) {
                var date = value ? new Date(value) : null;
                if (value) {
                    date =
                        format == 'date-time'
                            ? new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()))
                            : new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
                }
                return key + " " + column.filterOperator + " " + (date ? date.toISOString() : 'null');
            }
            else if (format == 'time') {
                return key + " " + column.filterOperator + " duration'" + filter.value + "'";
            }
            else if (format == 'uuid') {
                return key + " " + column.filterOperator + " " + value;
            }
            else if (value && column.filterOperator == 'contains') {
                return "contains(" + key + ", '" + value + "')";
            }
            else if (value && column.filterOperator == 'startswith') {
                return "startswith(" + key + ", '" + value + "')";
            }
            else if (value && column.filterOperator == 'endswith') {
                return "endswith(" + key + ", '" + value + "')";
            }
            else if (value && column.filterOperator == 'eq') {
                return key + " eq '" + value + "'";
            }
        }
        else if ((column.type == 'number' || column.type == 'integer') &&
            !isNaN(+value)) {
            return key + " " + column.filterOperator + " " + value;
        }
        else if (column.type == 'boolean') {
            return key + " eq " + value;
        }
        else {
            return null;
        }
    }
    return null;
}
var GridModule = /** @class */ (function () {
    function GridModule() {
    }
    GridModule = __decorate([
        core_1.NgModule({
            imports: [
                common_1.CommonModule,
                shared_1.SharedModule,
                forms_1.FormsModule,
                calendar_1.CalendarModule,
                datatable_1.DataTableModule,
                listbox_1.ListboxModule,
                tristatecheckbox_1.TriStateCheckboxModule,
                overlaypanel_1.OverlayPanelModule,
                button_1.ButtonModule,
                numeric_1.NumericModule,
                confirmdialog_1.ConfirmDialogModule
            ],
            declarations: [
                GridComponent,
                GridColumn,
                GridTemplateDirective,
                GridColumnTemplate,
                GridColumnEditTemplate,
                GridColumnFooterTemplate
            ],
            exports: [
                GridComponent,
                GridColumn,
                GridTemplateDirective,
                GridColumnTemplate,
                GridColumnEditTemplate,
                GridColumnFooterTemplate
            ]
        })
    ], GridModule);
    return GridModule;
}());
exports.GridModule = GridModule;
