"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var transition_1 = require("./transition");
var layout_1 = require("./layout");
var HeaderComponent = /** @class */ (function () {
    function HeaderComponent(layoutService) {
        this.layoutService = layoutService;
        this.fixed = true;
        this.style = {};
    }
    HeaderComponent.prototype.ngDoCheck = function () {
        this.layoutService.headerHeight.next(this.fixed ? this.header.nativeElement.offsetHeight : 0);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], HeaderComponent.prototype, "fixed", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], HeaderComponent.prototype, "style", void 0);
    __decorate([
        core_1.ViewChild('header'),
        __metadata("design:type", core_1.ElementRef)
    ], HeaderComponent.prototype, "header", void 0);
    __decorate([
        core_1.ViewChild(layout_1.OffsetBySidebarDirective),
        __metadata("design:type", layout_1.OffsetBySidebarDirective)
    ], HeaderComponent.prototype, "offset", void 0);
    HeaderComponent = __decorate([
        core_1.Component({
            selector: 'rz-header',
            template: "\n  <div #header class=\"header\" rz-offset-by-sidebar [ngStyle]=\"style\" [ngClass]=\"{fixed:fixed}\"\n    [@open]=\"{value: offset.sidebarOpen && offset.sidebarStretch ? 'visible': 'hidden', params: {marginLeft: offset.sidebarWidth}}\">\n    <ng-content></ng-content>\n  </div>\n  ",
            animations: [transition_1.sidebarAnimation]
        }),
        __metadata("design:paramtypes", [layout_1.LayoutService])
    ], HeaderComponent);
    return HeaderComponent;
}());
exports.HeaderComponent = HeaderComponent;
var HeaderModule = /** @class */ (function () {
    function HeaderModule() {
    }
    HeaderModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, layout_1.LayoutModule],
            declarations: [HeaderComponent],
            exports: [HeaderComponent]
        })
    ], HeaderModule);
    return HeaderModule;
}());
exports.HeaderModule = HeaderModule;
