"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var dropdown_1 = require("primeng/dropdown");
var LanguagePickerItemComponent = /** @class */ (function () {
    function LanguagePickerItemComponent() {
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LanguagePickerItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LanguagePickerItemComponent.prototype, "value", void 0);
    LanguagePickerItemComponent = __decorate([
        core_1.Component({
            selector: 'rz-languagepicker-item',
            template: ""
        })
    ], LanguagePickerItemComponent);
    return LanguagePickerItemComponent;
}());
exports.LanguagePickerItemComponent = LanguagePickerItemComponent;
var LanguagePickerComponent = /** @class */ (function () {
    function LanguagePickerComponent() {
        this.style = {};
    }
    LanguagePickerComponent.prototype.onChange = function (value) {
        var path = location.href.replace(this.value, value);
        if (!location.href.startsWith(path)) {
            location.href = path;
        }
    };
    LanguagePickerComponent.prototype.ngAfterContentInit = function () {
        this.options = this.items.map(function (item) {
            return {
                label: item.text,
                value: item.value
            };
        });
        var option = this.options.find(function (option) { return location.href.indexOf("/" + option.value) >= 0; });
        if (option) {
            this.value = option.value;
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LanguagePickerComponent.prototype, "style", void 0);
    __decorate([
        core_1.ContentChildren(LanguagePickerItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], LanguagePickerComponent.prototype, "items", void 0);
    LanguagePickerComponent = __decorate([
        core_1.Component({
            selector: 'rz-languagepicker',
            template: "\n    <p-dropdown\n      [options]=\"options\"\n      [ngModel]=\"value\"\n      appendTo=\"body\"\n      [style]=\"style\"\n      (onChange)=\"onChange($event.value)\"\n    >\n    </p-dropdown>\n  "
        })
    ], LanguagePickerComponent);
    return LanguagePickerComponent;
}());
exports.LanguagePickerComponent = LanguagePickerComponent;
var LanguagePickerModule = /** @class */ (function () {
    function LanguagePickerModule() {
    }
    LanguagePickerModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, dropdown_1.DropdownModule],
            declarations: [LanguagePickerComponent, LanguagePickerItemComponent],
            exports: [LanguagePickerComponent, LanguagePickerItemComponent]
        })
    ], LanguagePickerModule);
    return LanguagePickerModule;
}());
exports.LanguagePickerModule = LanguagePickerModule;
