"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var get = require("lodash/get");
var form_field_1 = require("./form-field");
var LookupFormFieldTemplate = /** @class */ (function () {
    function LookupFormFieldTemplate(templateRef) {
        this.templateRef = templateRef;
    }
    LookupFormFieldTemplate = __decorate([
        core_1.Directive({
            selector: '[lookupFormFieldTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], LookupFormFieldTemplate);
    return LookupFormFieldTemplate;
}());
exports.LookupFormFieldTemplate = LookupFormFieldTemplate;
var LookupFormFieldComponent = /** @class */ (function (_super) {
    __extends(LookupFormFieldComponent, _super);
    function LookupFormFieldComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.allowFiltering = false;
        _this.allowClear = false;
        _this.multiple = false;
        _this.multipleItemsSelectedText = '{0} items selected';
        return _this;
    }
    LookupFormFieldComponent_1 = LookupFormFieldComponent;
    LookupFormFieldComponent.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('data') ||
            changes.hasOwnProperty('textProperty') ||
            changes.hasOwnProperty('valueProperty')) {
            this.setOptions();
        }
    };
    LookupFormFieldComponent.prototype.setOptions = function () {
        var _this = this;
        if (!this.data) {
            return;
        }
        this.options = this.data.map(function (item) {
            return {
                data: item,
                label: _this.textProperty ? get(item, _this.textProperty) : item,
                value: _this.valueProperty ? get(item, _this.valueProperty) : item
            };
        });
    };
    var LookupFormFieldComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LookupFormFieldComponent.prototype, "textProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LookupFormFieldComponent.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], LookupFormFieldComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], LookupFormFieldComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LookupFormFieldComponent.prototype, "allowFiltering", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LookupFormFieldComponent.prototype, "allowClear", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LookupFormFieldComponent.prototype, "multiple", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], LookupFormFieldComponent.prototype, "multipleItemsSelectedText", void 0);
    __decorate([
        core_1.ContentChild(LookupFormFieldTemplate),
        __metadata("design:type", LookupFormFieldTemplate)
    ], LookupFormFieldComponent.prototype, "template", void 0);
    LookupFormFieldComponent = LookupFormFieldComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-lookup-form-field',
            template: "\n    <p-dropdown\n      appendTo=\"body\"\n      *ngIf=\"data && !multiple\"\n      [filter]=\"allowFiltering\"\n      [inputId]=\"property\"\n      [placeholder]=\"placeholder\"\n      [options]=\"options\"\n      [showClear]=\"allowClear\"\n      [formControl]=\"control\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-item>\n        <ng-template\n          [ngTemplateOutlet]=\"template.templateRef\"\n          [ngTemplateOutletContext]=\"{$implicit: item.data}\"\n        >\n        </ng-template>\n      </ng-template>\n      <ng-template *ngIf=\"template\" pTemplate=\"selectedItem\" let-item>\n        <ng-template\n          [ngTemplateOutlet]=\"template.templateRef\"\n          [ngTemplateOutletContext]=\"{$implicit: item.data}\"\n        >\n        </ng-template>\n      </ng-template>\n    </p-dropdown>\n    <p-multiSelect\n      appendTo=\"body\"\n      *ngIf=\"data && multiple\"\n      [filter]=\"allowFiltering\"\n      [defaultLabel]=\"placeholder\"\n      [inputId]=\"property\"\n      [options]=\"options\"\n      [selectedItemsLabel]=\"multipleItemsSelectedText\"\n      [formControl]=\"control\"\n    >\n      <ng-template *ngIf=\"template\" pTemplate=\"item\" let-item>\n        <ng-template\n          [ngTemplateOutlet]=\"template.templateRef\"\n          [ngTemplateOutletContext]=\"{$implicit: item.data}\"\n        >\n        </ng-template>\n      </ng-template>\n    </p-multiSelect>\n    <div\n      class=\"md-inputfield\"\n      *ngIf=\"(control.touched || submitted) && control.errors?.required\"\n    >\n      <div class=\"ui-message ui-messages-error ui-corner-all\">\n        {{ title }} {{ requiredText }}\n      </div>\n    </div>\n  ",
            providers: [
                {
                    provide: form_field_1.FormFieldComponent,
                    useExisting: core_1.forwardRef(function () { return LookupFormFieldComponent_1; })
                }
            ]
        })
    ], LookupFormFieldComponent);
    return LookupFormFieldComponent;
}(form_field_1.FormFieldComponent));
exports.LookupFormFieldComponent = LookupFormFieldComponent;
