"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var growl_1 = require("primeng/growl");
var NotificationService = /** @class */ (function () {
    function NotificationService(componentFactoryResolver, applicationRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.messages = [];
    }
    NotificationService.prototype.notify = function (message) {
        var _this = this;
        this.init();
        this.messages = this.messages.concat(message);
        this.componentRef.instance.value = this.messages;
        this.componentRef.instance.life = message.duration || 3000;
        var subject = new rxjs_1.Subject();
        var subscription = this.componentRef.instance.onClose.subscribe(function (event) {
            if (event.message == message) {
                _this.messages = _this.messages.filter(function (message) { return message !== event.message; });
                subject.next();
                subject.complete();
                subscription.unsubscribe();
            }
        });
        return subject;
    };
    NotificationService.prototype.init = function () {
        if (this.componentRef) {
            return;
        }
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(growl_1.Growl);
        this.componentRef = componentFactory.create(this.injector);
        this.componentRef.instance.value = this.messages;
        this.applicationRef.attachView(this.componentRef.hostView);
        document.body.appendChild(this.componentRef.hostView.rootNodes[0]);
    };
    NotificationService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver,
            core_1.ApplicationRef,
            core_1.Injector])
    ], NotificationService);
    return NotificationService;
}());
exports.NotificationService = NotificationService;
var NotificationModule = /** @class */ (function () {
    function NotificationModule() {
    }
    NotificationModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, growl_1.GrowlModule],
            providers: [NotificationService],
            entryComponents: [growl_1.Growl]
        })
    ], NotificationModule);
    return NotificationModule;
}());
exports.NotificationModule = NotificationModule;
