"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var form_field_1 = require("./form-field");
var NumericFormField = /** @class */ (function (_super) {
    __extends(NumericFormField, _super);
    function NumericFormField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.placeholder = '';
        _this.autoComplete = true;
        _this.minText = 'cannot be less than';
        _this.maxText = 'cannot be more than';
        return _this;
    }
    Object.defineProperty(NumericFormField.prototype, "min", {
        get: function () {
            return this._min;
        },
        set: function (value) {
            this._min = value;
            this.updateValidators();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericFormField.prototype, "max", {
        get: function () {
            return this._max;
        },
        set: function (value) {
            this._max = value;
            this.updateValidators();
        },
        enumerable: true,
        configurable: true
    });
    NumericFormField.prototype.parse = function (value) {
        return Number(value);
    };
    NumericFormField.prototype.updateValidators = function () {
        if (this.control) {
            var validators = [];
            if (this.required) {
                validators.push(forms_1.Validators.required);
            }
            if (this.min != null) {
                validators.push(forms_1.Validators.min(this.min));
            }
            if (this.max != null) {
                validators.push(forms_1.Validators.max(this.max));
            }
            this.control.setValidators(validators);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NumericFormField.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericFormField.prototype, "autoComplete", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericFormField.prototype, "minText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericFormField.prototype, "maxText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], NumericFormField.prototype, "min", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], NumericFormField.prototype, "max", null);
    return NumericFormField;
}(form_field_1.FormFieldComponent));
exports.NumericFormField = NumericFormField;
var NumberFormFieldComponent = /** @class */ (function (_super) {
    __extends(NumberFormFieldComponent, _super);
    function NumberFormFieldComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberFormFieldComponent_1 = NumberFormFieldComponent;
    var NumberFormFieldComponent_1;
    NumberFormFieldComponent = NumberFormFieldComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-number-form-field',
            template: "\n    <rz-numeric\n      [formControl]=\"control\"\n      [placeholder]=\"placeholder\"\n      [autoComplete]=\"autoComplete\"\n      [min]=\"min\"\n      [max]=\"max\"\n      [name]=\"property\"\n    ></rz-numeric>\n    <div\n      class=\"md-inputfield\"\n      *ngIf=\"(control.touched || submitted) && control.errors?.required\"\n    >\n      <div class=\"ui-message ui-messages-error ui-corner-all\">\n        {{ title }} {{ requiredText }}\n      </div>\n    </div>\n    <div\n      class=\"md-inputfield\"\n      *ngIf=\"(control.touched || submitted) && control.errors?.min\"\n    >\n      <div class=\"ui-message ui-messages-error ui-corner-all\">\n        {{ title }} {{ minText }} {{ min }}\n      </div>\n    </div>\n    <div\n      class=\"md-inputfield\"\n      *ngIf=\"(control.touched || submitted) && control.errors?.max\"\n    >\n      <div class=\"ui-message ui-messages-error ui-corner-all\">\n        {{ title }} {{ maxText }} {{ max }}\n      </div>\n    </div>\n  ",
            providers: [
                {
                    provide: form_field_1.FormFieldComponent,
                    useExisting: core_1.forwardRef(function () { return NumberFormFieldComponent_1; })
                }
            ]
        })
    ], NumberFormFieldComponent);
    return NumberFormFieldComponent;
}(NumericFormField));
exports.NumberFormFieldComponent = NumberFormFieldComponent;
