"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var validator_1 = require("./validator");
var NumericRangeValidatorComponent = /** @class */ (function (_super) {
    __extends(NumericRangeValidatorComponent, _super);
    function NumericRangeValidatorComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.text = "Not in the valid range";
        _this.min = 0;
        return _this;
    }
    Object.defineProperty(NumericRangeValidatorComponent.prototype, "validate", {
        get: function () {
            var validator = null;
            if (!isNaN(this.min)) {
                validator = forms_1.Validators.min(this.min);
            }
            if (!isNaN(this.max)) {
                var max = forms_1.Validators.max(this.max);
                if (validator) {
                    validator = forms_1.Validators.compose([validator, max]);
                }
                else {
                    validator = max;
                }
            }
            return validator;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NumericRangeValidatorComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], NumericRangeValidatorComponent.prototype, "min", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], NumericRangeValidatorComponent.prototype, "max", void 0);
    NumericRangeValidatorComponent = __decorate([
        core_1.Component({
            selector: 'rz-numeric-range-validator',
            template: "\n    <div\n      [ngStyle]=\"style\"\n      class=\"ui-message ui-messages-error\"\n      [ngClass]=\"{'ui-message-popup': popup}\"\n      *ngIf=\"\n        token ||\n        ((control?.errors?.min || control?.errors?.max) &&\n          (control?.touched || control?.dirty || form?.ngForm?.submitted))\n      \"\n    >\n      {{ text }}\n    </div>\n  "
        })
    ], NumericRangeValidatorComponent);
    return NumericRangeValidatorComponent;
}(validator_1.ValidatorComponent));
exports.NumericRangeValidatorComponent = NumericRangeValidatorComponent;
var NumericRangeValidatorModule = /** @class */ (function () {
    function NumericRangeValidatorModule() {
    }
    NumericRangeValidatorModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [NumericRangeValidatorComponent],
            exports: [NumericRangeValidatorComponent]
        })
    ], NumericRangeValidatorModule);
    return NumericRangeValidatorModule;
}());
exports.NumericRangeValidatorModule = NumericRangeValidatorModule;
