"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var menu_1 = require("./menu");
var navigation_1 = require("./navigation");
var template_form_1 = require("./template-form");
var ProfileMenuItemComponent = /** @class */ (function (_super) {
    __extends(ProfileMenuItemComponent, _super);
    function ProfileMenuItemComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProfileMenuItemComponent_1 = ProfileMenuItemComponent;
    var ProfileMenuItemComponent_1;
    __decorate([
        core_1.ContentChildren(ProfileMenuItemComponent_1),
        __metadata("design:type", core_1.QueryList)
    ], ProfileMenuItemComponent.prototype, "items", void 0);
    ProfileMenuItemComponent = ProfileMenuItemComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-profilemenu-item',
            template: ""
        })
    ], ProfileMenuItemComponent);
    return ProfileMenuItemComponent;
}(navigation_1.NavigationItemComponent));
exports.ProfileMenuItemComponent = ProfileMenuItemComponent;
var ProfileMenuTemplateDirective = /** @class */ (function () {
    function ProfileMenuTemplateDirective(template) {
        this.template = template;
    }
    ProfileMenuTemplateDirective = __decorate([
        core_1.Directive({
            selector: '[profilemenuTemplate]'
        }),
        __metadata("design:paramtypes", [core_1.TemplateRef])
    ], ProfileMenuTemplateDirective);
    return ProfileMenuTemplateDirective;
}());
exports.ProfileMenuTemplateDirective = ProfileMenuTemplateDirective;
var ProfileMenuComponent = /** @class */ (function () {
    function ProfileMenuComponent() {
        var _this = this;
        this.style = {};
        this.click = new core_1.EventEmitter();
        this.ngUnsubscribe = new rxjs_1.Subject();
        this.childrenToItems = function () {
            _this.items = navigation_1.childrenToItems(_this.children.toArray());
        };
    }
    ProfileMenuComponent.prototype.ngAfterContentInit = function () {
        if (this.children) {
            this.childrenToItems();
            this.children.changes.subscribe(this.childrenToItems);
        }
    };
    ProfileMenuComponent.prototype.ngOnDestroy = function () {
        this.ngUnsubscribe.next();
        this.ngUnsubscribe.complete();
    };
    ProfileMenuComponent.prototype.onClick = function (event) {
        this.click.next(event);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], ProfileMenuComponent.prototype, "items", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ProfileMenuComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ProfileMenuComponent.prototype, "click", void 0);
    __decorate([
        core_1.ContentChildren(ProfileMenuItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], ProfileMenuComponent.prototype, "children", void 0);
    __decorate([
        core_1.ContentChild(ProfileMenuTemplateDirective),
        __metadata("design:type", ProfileMenuTemplateDirective)
    ], ProfileMenuComponent.prototype, "profileTemplate", void 0);
    ProfileMenuComponent = __decorate([
        core_1.Component({
            selector: 'rz-profilemenu',
            providers: [template_form_1.hideTemplateFromTemplateForm()],
            template: "\n    <rz-menu [style]=\"style\" class=\"profile-menu\" (click)=\"onClick($event)\">\n      <rz-menu-item [template]=\"profileTemplate?.template\">\n        <rz-menu-item\n          *ngFor=\"let item of items\"\n          [text]=\"item.text\"\n          [icon]=\"item.icon\"\n          [path]=\"item.path\"\n        >\n        </rz-menu-item>\n      </rz-menu-item>\n    </rz-menu>\n  "
        })
    ], ProfileMenuComponent);
    return ProfileMenuComponent;
}());
exports.ProfileMenuComponent = ProfileMenuComponent;
var ProfileMenuModule = /** @class */ (function () {
    function ProfileMenuModule() {
    }
    ProfileMenuModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, menu_1.MenuModule],
            declarations: [
                ProfileMenuTemplateDirective,
                ProfileMenuComponent,
                ProfileMenuItemComponent
            ],
            exports: [
                ProfileMenuTemplateDirective,
                ProfileMenuComponent,
                ProfileMenuItemComponent
            ]
        })
    ], ProfileMenuModule);
    return ProfileMenuModule;
}());
exports.ProfileMenuModule = ProfileMenuModule;
