"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var splitbutton_1 = require("primeng/splitbutton");
var SplitButtonItemComponent = /** @class */ (function () {
    function SplitButtonItemComponent() {
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SplitButtonItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SplitButtonItemComponent.prototype, "value", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SplitButtonItemComponent.prototype, "icon", void 0);
    SplitButtonItemComponent = __decorate([
        core_1.Component({
            selector: 'rz-splitbutton-item',
            template: ''
        })
    ], SplitButtonItemComponent);
    return SplitButtonItemComponent;
}());
exports.SplitButtonItemComponent = SplitButtonItemComponent;
var SplitButtonComponent = /** @class */ (function () {
    function SplitButtonComponent(elementRef) {
        this.text = '';
        this.style = {};
        this.disabled = false;
        this.visible = true;
        this.click = new core_1.EventEmitter();
        this.items = [];
        this.elementRef = elementRef;
    }
    SplitButtonComponent.prototype.onClick = function (event) {
        event.stopPropagation();
        this.click.next({ text: this.text });
    };
    SplitButtonComponent.prototype.onDropdownClick = function (event) {
        event.stopPropagation();
    };
    SplitButtonComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.createItems();
        this.subscription = this.children.changes.subscribe(function () {
            return _this.createItems();
        });
        if (this.icon) {
            var icon = this.elementRef.nativeElement.querySelector("p-splitbutton > div > button.ui-button > span");
            if (icon) {
                icon.innerText = this.icon;
            }
        }
    };
    SplitButtonComponent.prototype.ngAfterViewChecked = function () {
        for (var index = 0; index < this.items.length; index++) {
            var item = this.items[index];
            if (item.icon) {
                var icon = this.elementRef.nativeElement.querySelector("p-splitbutton > div > div > ul > li:nth-child(" + (index +
                    1) + ") > a > span.ui-menuitem-icon");
                if (icon) {
                    icon.innerText = item.icon;
                }
            }
        }
    };
    SplitButtonComponent.prototype.ngOnDestroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    SplitButtonComponent.prototype.createItems = function () {
        var _this = this;
        if (!this.children) {
            return;
        }
        this.items = this.children.map(function (option) {
            return {
                label: option.text,
                id: option.value != null ? option.value : option.text,
                icon: option.icon,
                command: function () {
                    setTimeout(function () { return _this.click.next(option); });
                }
            };
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SplitButtonComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SplitButtonComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SplitButtonComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SplitButtonComponent.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SplitButtonComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], SplitButtonComponent.prototype, "click", void 0);
    __decorate([
        core_1.ContentChildren(SplitButtonItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], SplitButtonComponent.prototype, "children", void 0);
    SplitButtonComponent = __decorate([
        core_1.Component({
            selector: 'rz-splitbutton',
            template: "\n    <p-splitButton\n      [disabled]=\"disabled\"\n      appendTo=\"body\"\n      [style]=\"style\"\n      [icon]=\"icon ? 'pi' : null\"\n      [label]=\"text\"\n      [model]=\"items\"\n      (onClick)=\"onClick($event)\"\n      (onDropdownClick)=\"onDropdownClick($event)\"\n    >\n    </p-splitButton>\n  "
        }),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], SplitButtonComponent);
    return SplitButtonComponent;
}());
exports.SplitButtonComponent = SplitButtonComponent;
var SplitButtonModule = /** @class */ (function () {
    function SplitButtonModule() {
    }
    SplitButtonModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, splitbutton_1.SplitButtonModule],
            declarations: [SplitButtonItemComponent, SplitButtonComponent],
            exports: [SplitButtonItemComponent, SplitButtonComponent]
        })
    ], SplitButtonModule);
    return SplitButtonModule;
}());
exports.SplitButtonModule = SplitButtonModule;
