"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var shared_1 = require("./shared");
var SSRSViewerParameter = /** @class */ (function () {
    function SSRSViewerParameter() {
    }
    return SSRSViewerParameter;
}());
exports.SSRSViewerParameter = SSRSViewerParameter;
var SSRSViewerParameterComponent = /** @class */ (function () {
    function SSRSViewerParameterComponent(parent) {
        this.parent = parent;
    }
    Object.defineProperty(SSRSViewerParameterComponent.prototype, "parameterName", {
        get: function () {
            return this._parameterName;
        },
        set: function (value) {
            this._parameterName = value;
            if (this.parent) {
                this.parent.setReportUrl();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SSRSViewerParameterComponent.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (value) {
            this._value = value;
            if (this.parent) {
                this.parent.setReportUrl();
            }
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], SSRSViewerParameterComponent.prototype, "parameterName", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], SSRSViewerParameterComponent.prototype, "value", null);
    SSRSViewerParameterComponent = __decorate([
        core_1.Component({
            selector: 'rz-ssrsviewer-parameter',
            template: ''
        }),
        __param(0, core_1.Host()),
        __param(0, core_1.Inject(core_1.forwardRef(function () { return SSRSViewerComponent; }))),
        __metadata("design:paramtypes", [SSRSViewerComponent])
    ], SSRSViewerParameterComponent);
    return SSRSViewerParameterComponent;
}());
exports.SSRSViewerParameterComponent = SSRSViewerParameterComponent;
var SSRSViewerComponent = /** @class */ (function () {
    function SSRSViewerComponent(hostElement) {
        this.hostElement = hostElement;
        this.style = {};
        this.visible = true;
        this.useProxy = false;
        this.parameters = [];
    }
    SSRSViewerComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.iframe = this.hostElement.nativeElement.querySelector('iframe');
        this.setReportUrl();
        this.subscription = this.children.changes.subscribe(function () {
            return _this.setReportUrl();
        });
    };
    SSRSViewerComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    SSRSViewerComponent.prototype.setReportUrl = function () {
        this.parameters =
            this.children &&
                this.children.map(function (child) {
                    return {
                        parameterName: child.parameterName,
                        value: child.value
                    };
                });
        var params = this.parameters
            ? this.parameters
                .filter(function (p) { return p.parameterName; })
                .map(function (p) { return p.parameterName + "=" + p.value; })
                .join('&')
            : '';
        var url = this.reportServer && this.reportName
            ? this.reportServer + "/Pages/ReportViewer.aspx?%2f" + this.reportName + "&rs:Command=Render&rs:Embed=true" + (params ? '&' + params : '')
            : '';
        var newUrl;
        if (this.useProxy) {
            if (this.localServer) {
                newUrl = this.localServer + "/__ssrsreport?url=" + encodeURIComponent(url);
            }
            else {
                var base = document.querySelector('base');
                var baseHref = (base && base.href) || '';
                if (baseHref.endsWith('/')) {
                    baseHref = baseHref.substring(0, baseHref.length - 1);
                }
                newUrl = baseHref + "/__ssrsreport?url=" + encodeURIComponent(url);
            }
        }
        else {
            newUrl = url;
        }
        if (this.reportUrl != newUrl) {
            this.reportUrl = newUrl;
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SSRSViewerComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SSRSViewerComponent.prototype, "name", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SSRSViewerComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SSRSViewerComponent.prototype, "useProxy", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SSRSViewerComponent.prototype, "localServer", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SSRSViewerComponent.prototype, "reportServer", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SSRSViewerComponent.prototype, "reportName", void 0);
    __decorate([
        core_1.ContentChildren(SSRSViewerParameterComponent),
        __metadata("design:type", core_1.QueryList)
    ], SSRSViewerComponent.prototype, "children", void 0);
    SSRSViewerComponent = __decorate([
        core_1.Component({
            selector: 'rz-ssrsviewer',
            template: "\n    <div class=\"ssrsviewer\" [ngStyle]=\"style\">\n      <iframe [id]=\"name\" frameborder=\"0\" [src]=\"reportUrl | safe\"> </iframe>\n    </div>\n  "
        }),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], SSRSViewerComponent);
    return SSRSViewerComponent;
}());
exports.SSRSViewerComponent = SSRSViewerComponent;
var SSRSViewerModule = /** @class */ (function () {
    function SSRSViewerModule() {
    }
    SSRSViewerModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, shared_1.SharedModule],
            declarations: [SSRSViewerComponent, SSRSViewerParameterComponent],
            exports: [SSRSViewerComponent, SSRSViewerParameterComponent]
        })
    ], SSRSViewerModule);
    return SSRSViewerModule;
}());
exports.SSRSViewerModule = SSRSViewerModule;
