"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var rxjs_1 = require("rxjs");
var common_1 = require("@angular/common");
var dates_1 = require("./dates");
var InputComponent = /** @class */ (function () {
    function InputComponent(templateForm) {
        this.templateForm = templateForm;
        this.name = '';
        this.disabled = false;
        this.change = new core_1.EventEmitter();
        this.validators = [];
        this.onChange = function (value) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(InputComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                this.change.next(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    InputComponent.prototype.writeValue = function (value) {
        this.innerValue = value;
    };
    InputComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    InputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    InputComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    InputComponent.prototype.registerValidator = function (validator) {
        this.validators.push(validator);
    };
    InputComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.ngModel) {
            this.ngModel.name = this.name;
            this.validators.forEach(function (validator) {
                return validator.applyTo(_this.ngModel.control);
            });
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], InputComponent.prototype, "name", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], InputComponent.prototype, "disabled", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], InputComponent.prototype, "change", void 0);
    __decorate([
        core_1.ViewChild(forms_1.NgModel),
        __metadata("design:type", forms_1.NgModel)
    ], InputComponent.prototype, "ngModel", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputComponent.prototype, "value", null);
    InputComponent = __decorate([
        __param(0, core_1.SkipSelf()),
        __param(0, core_1.Optional()),
        __param(0, core_1.Host()),
        __param(0, core_1.Inject(core_1.forwardRef(function () { return TemplateFormComponent; }))),
        __metadata("design:paramtypes", [TemplateFormComponent])
    ], InputComponent);
    return InputComponent;
}());
exports.InputComponent = InputComponent;
var TemplateFormComponent = /** @class */ (function () {
    function TemplateFormComponent() {
        this.ngUnsubscribe = new rxjs_1.Subject();
        this.style = {};
        this.submit = new core_1.EventEmitter();
    }
    Object.defineProperty(TemplateFormComponent.prototype, "valid", {
        get: function () {
            return this.ngForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    TemplateFormComponent.prototype.onSubmit = function (event) {
        event.preventDefault();
        event.stopPropagation();
        if (this.ngForm.valid) {
            var value_1 = this.ngForm.value;
            this.components.forEach(function (component) {
                if (component.utc) {
                    value_1[component.name] = Array.isArray(component.value)
                        ? component.value.map(dates_1.toUTC)
                        : dates_1.toUTC(component.value);
                }
            });
            this.submit.next(value_1);
        }
    };
    TemplateFormComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.fields = [];
        this.components.changes
            .pipe(operators_1.takeUntil(this.ngUnsubscribe), operators_1.startWith(this.components.changes))
            .subscribe(function () {
            _this.components.forEach(function (component) {
                if (component.templateForm === _this) {
                    _this.fields.push({ property: component.name });
                    _this.ngForm.addControl(component.ngModel);
                }
            });
        });
    };
    TemplateFormComponent.prototype.ngOnDestroy = function () {
        this.ngUnsubscribe.next();
        this.ngUnsubscribe.complete();
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TemplateFormComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TemplateFormComponent.prototype, "submit", void 0);
    __decorate([
        core_1.ViewChild(forms_1.NgForm),
        __metadata("design:type", forms_1.NgForm)
    ], TemplateFormComponent.prototype, "ngForm", void 0);
    __decorate([
        core_1.ContentChildren(InputComponent, { descendants: true }),
        __metadata("design:type", core_1.QueryList)
    ], TemplateFormComponent.prototype, "components", void 0);
    TemplateFormComponent = __decorate([
        core_1.Component({
            selector: 'rz-template-form',
            template: "\n    <form\n      class=\"ui-template-form\"\n      [ngStyle]=\"style\"\n      (submit)=\"onSubmit($event)\"\n    >\n      <ng-content></ng-content>\n    </form>\n  "
        })
    ], TemplateFormComponent);
    return TemplateFormComponent;
}());
exports.TemplateFormComponent = TemplateFormComponent;
var TemplateFormModule = /** @class */ (function () {
    function TemplateFormModule() {
    }
    TemplateFormModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule],
            declarations: [TemplateFormComponent],
            exports: [TemplateFormComponent]
        })
    ], TemplateFormModule);
    return TemplateFormModule;
}());
exports.TemplateFormModule = TemplateFormModule;
function hideTemplateFromTemplateForm() {
    return {
        provide: TemplateFormComponent,
        useValue: null
    };
}
exports.hideTemplateFromTemplateForm = hideTemplateFromTemplateForm;
