"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var treetable_1 = require("primeng/treetable");
var template_form_1 = require("./template-form");
var TreeGridColumn = /** @class */ (function () {
    function TreeGridColumn() {
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TreeGridColumn.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TreeGridColumn.prototype, "property", void 0);
    TreeGridColumn = __decorate([
        core_1.Component({
            selector: 'rz-treegrid-column',
            template: ''
        })
    ], TreeGridColumn);
    return TreeGridColumn;
}());
exports.TreeGridColumn = TreeGridColumn;
var TreeGridComponent = /** @class */ (function () {
    function TreeGridComponent() {
        this.style = {};
        this.data = [];
        this.nodeExpand = new core_1.EventEmitter();
        this.nodeSelect = new core_1.EventEmitter();
        this.nodeLoaded = new core_1.EventEmitter();
        this.results = [];
    }
    TreeGridComponent.prototype.ngAfterContentInit = function () {
        this.update();
    };
    TreeGridComponent.prototype.onClick = function (event, rowNode, tt) {
        rowNode.node.expanded = !rowNode.node.expanded;
        if (rowNode.node.expanded) {
            tt.onNodeExpand.emit({
                originalEvent: event,
                node: rowNode.node
            });
        }
        else {
            tt.onNodeCollapse.emit({
                originalEvent: event,
                node: rowNode.node
            });
        }
        tt.updateSerializedValue();
        tt.tableService.onUIUpdate(tt.value);
        event.preventDefault();
    };
    TreeGridComponent.prototype.ngOnChanges = function (changes) {
        this.update();
    };
    TreeGridComponent.prototype.update = function () {
        var _this = this;
        if (this.data) {
            this.results = this.data.map(function (item) {
                var node = {
                    data: item,
                    children: [],
                    leaf: false
                };
                _this.nodeLoaded.next(new TreeGridNodeLoadedData(node, 0));
                return node;
            });
        }
    };
    TreeGridComponent.prototype.reload = function () {
        this.results = this.results.slice();
    };
    TreeGridComponent.prototype.onNodeSelect = function (event) {
        if (event.node) {
            this.nodeSelect.next({
                data: event.node.data,
                level: geLevelIndex(event.node)
            });
        }
    };
    TreeGridComponent.prototype.onNodeExpand = function (event) {
        if (event.node) {
            var level = geLevelIndex(event.node);
            this.nodeExpand.next(new TreeGridLoadChildrenData(level, event.node, this.nodeLoaded, this));
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeGridComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], TreeGridComponent.prototype, "data", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TreeGridComponent.prototype, "nodeExpand", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TreeGridComponent.prototype, "nodeSelect", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TreeGridComponent.prototype, "nodeLoaded", void 0);
    __decorate([
        core_1.ContentChildren(TreeGridColumn),
        __metadata("design:type", core_1.QueryList)
    ], TreeGridComponent.prototype, "columns", void 0);
    TreeGridComponent = __decorate([
        core_1.Component({
            selector: 'rz-treegrid',
            providers: [template_form_1.hideTemplateFromTemplateForm()],
            template: "\n    <p-treeTable\n      #tt\n      [value]=\"results\"\n      selectionMode=\"single\"\n      compareSelectionBy=\"equals\"\n      [columns]=\"columns\"\n      [(selection)]=\"selectedNode\"\n      (onNodeSelect)=\"onNodeSelect($event)\"\n      (onNodeExpand)=\"onNodeExpand($event)\"\n      [style]=\"style\"\n      ><ng-template pTemplate=\"header\" let-columns>\n        <tr>\n          <th *ngFor=\"let column of columns\">\n            <span class=\"ui-column-title\">{{ column.title }}</span>\n          </th>\n        </tr>\n      </ng-template>\n      <ng-template\n        pTemplate=\"body\"\n        let-rowNode\n        let-rowData=\"rowData\"\n        let-columns=\"columns\"\n      >\n        <tr [ttRow]=\"rowNode\" [ttSelectableRow]=\"rowNode\">\n          <td *ngFor=\"let column of columns; let i = index\">\n            <a class=\"ui-treetable-toggler ui-unselectable-text\" *ngIf=\"i == 0\" (click)=\"onClick($event, rowNode, tt)\"\n                [style.visibility]=\"rowNode.node.leaf === false || (rowNode.node.children && rowNode.node.children.length) ? 'visible' : 'hidden'\" [style.marginLeft]=\"rowNode.level * 16 + 'px'\">\n                <i [ngClass]=\"rowNode.node.expanded ? 'pi pi-fw pi-chevron-down' : 'pi pi-fw pi-chevron-right'\"></i>\n            </a>\n            <span class=\"ng-star-inserted\">{{ rowData[column.property] }}</span>\n          </td>\n        </tr>\n      </ng-template>\n    </p-treeTable>\n  "
        })
    ], TreeGridComponent);
    return TreeGridComponent;
}());
exports.TreeGridComponent = TreeGridComponent;
var TreeGridNodeLoadedData = /** @class */ (function () {
    function TreeGridNodeLoadedData(node, level) {
        this.node = node;
        this.data = node.data;
        this.level = level;
    }
    Object.defineProperty(TreeGridNodeLoadedData.prototype, "leaf", {
        get: function () {
            return this.node.leaf;
        },
        set: function (value) {
            this.node.leaf = value;
        },
        enumerable: true,
        configurable: true
    });
    return TreeGridNodeLoadedData;
}());
var TreeGridLoadChildrenData = /** @class */ (function () {
    function TreeGridLoadChildrenData(level, node, nodeLoaded, treeGrid) {
        this.level = level;
        this.data = node.data;
        this.node = node;
        this.nodeLoaded = nodeLoaded;
        this.treeGrid = treeGrid;
    }
    Object.defineProperty(TreeGridLoadChildrenData.prototype, "children", {
        get: function () {
            return this.node.children;
        },
        set: function (value) {
            var _this = this;
            if (value != this.node.children) {
                this.node.children = value.map(function (item) {
                    var node = {
                        data: item,
                        children: [],
                        leaf: false
                    };
                    _this.nodeLoaded.next(new TreeGridNodeLoadedData(node, _this.level + 1));
                    return node;
                });
                this.treeGrid.reload();
            }
        },
        enumerable: true,
        configurable: true
    });
    return TreeGridLoadChildrenData;
}());
function geLevelIndex(node) {
    var i = 0;
    while (node && node.parent) {
        node = node.parent;
        i++;
    }
    return i;
}
var TreeGridModule = /** @class */ (function () {
    function TreeGridModule() {
    }
    TreeGridModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, treetable_1.TreeTableModule],
            declarations: [TreeGridColumn, TreeGridComponent],
            exports: [TreeGridColumn, TreeGridComponent]
        })
    ], TreeGridModule);
    return TreeGridModule;
}());
exports.TreeGridModule = TreeGridModule;
