export interface Response {
}
export interface Parameter {
    in?: string;
    name?: string;
    type?: string;
    format?: string;
    required?: boolean;
    items?: any;
}
export interface Operation {
    name: string;
    method: string;
    parameters: Array<Parameter>;
    responses: Array<Response>;
}
export interface Resources {
    [name: string]: Array<Operation>;
}
export interface Authorization {
    type: string;
    url: string;
}
export interface DataSource {
    authorization?: Authorization;
    resources: Resources;
    name: string;
    basePath: string;
    schemas: Array<Schema>;
    enums?: Array<Enum>;
    connector: string;
    connectorVersion?: string;
    withCredentials?: boolean;
    concurrency?: string;
    cascadeDelete?: boolean;
    type: string;
    version: string;
    host: string;
}
export interface Schema {
    name: string;
    table?: string;
    properties: Array<Property>;
    required: Array<string>;
}
export interface Enum {
    name: string;
    members: Array<Member>;
}
export interface Member {
    text: string;
    value: number;
}
export interface Property {
    name: string;
    originalName: string;
    properties?: Array<Property>;
    array?: boolean;
    key?: boolean;
    type: string;
    required: boolean;
}
export declare function swaggerToDataSource(swagger: any, https: boolean, runtimePath?: string, endPoint?: string): DataSource;
